VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'=========================================================================
'
'   You are free to use this source as long as this copyright message
'     appears on your program's "About" dialog:
'
'   Outlook Bar Project
'   Copyright (c) 2002 Vlad Vissoultchev (wqw@geocities.com)
'
'=========================================================================
Option Explicit
Private Const MODULE_NAME As String = "cButton"

Event GetControl(oValue As ctxOutlookBar)

'=========================================================================
' Public enums
'=========================================================================

Public Enum UcsButtonClassType
    ucsBtnClassItem = 0
    ucsBtnClassGroup = 1
    ucsBtnClassControl = 2
End Enum

Public Enum UcsIconStyle
    ucsIcsSmallIcons = 0
    ucsIcsLargeIcons = 1
End Enum

'=========================================================================
' API
'=========================================================================

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'=========================================================================
' Private constants and variables
'=========================================================================

Private m_sCaption              As String
Private m_imgSmallIcon          As StdPicture
Private m_imgLargeIcon          As StdPicture
Private m_sKey                  As String
Private m_vTag                  As Variant
Private m_sTooltipText          As String
Private m_oParent               As cButton
Private m_cItems                As cButtons
Private m_eClass                As UcsButtonClassType
Private m_eIconsType            As UcsIconStyle
#If DebugMode Then
    Private m_sDebugID          As String
#End If

'=========================================================================
' Properties
'=========================================================================

Property Get Caption() As String
    Caption = m_sCaption
End Property

Property Let Caption(sValue As String)
    m_sCaption = sValue
    pvPaintControl
End Property

Property Get SmallIcon() As StdPicture
    Set SmallIcon = m_imgSmallIcon
End Property

Property Set SmallIcon(ByVal oValue As StdPicture)
    Set m_imgSmallIcon = oValue
    pvPaintControl
End Property

Property Get LargeIcon() As StdPicture
    Set LargeIcon = m_imgLargeIcon
End Property

Property Set LargeIcon(ByVal oValue As StdPicture)
    Set m_imgLargeIcon = oValue
    pvPaintControl
End Property

Property Get Index() As Long
    If Not m_oParent Is Nothing Then
        For Index = 1 To m_oParent.GroupItems.Count
            If m_oParent.GroupItems(Index) Is Me Then
                Exit Property
            End If
        Next
    End If
End Property

Property Get Key() As String
    Key = m_sKey
End Property

Property Let Key(sValue As String)
    m_sKey = sValue
    '--- ToDo: fix key in Parent collection
End Property

Property Get Selected() As Boolean
    Dim oCtl As ctxOutlookBar
    
    Set oCtl = Control
    If Not oCtl Is Nothing Then
        Select Case m_eClass
        Case ucsBtnClassItem
            Selected = oCtl.SelectedItem Is Me
        Case ucsBtnClassGroup
            Selected = oCtl.SelectedGroup Is Me
        Case ucsBtnClassControl
            '--- always
            Selected = True
        End Select
    End If
End Property

Property Let Selected(ByVal bValue As Boolean)
    Dim oCtl As ctxOutlookBar
    
    Set oCtl = Control
    If Not oCtl Is Nothing Then
    If bValue = True Then
        If Not Parent Is Nothing Then
            Parent.Selected = True
        End If
        Select Case m_eClass
        Case ucsBtnClassItem
            Set oCtl.SelectedItem = Me
        Case ucsBtnClassGroup
            Set oCtl.SelectedGroup = Me
        Case ucsBtnClassControl
            '--- nothing to do
        End Select
    Else
        '--- if desected select first in parent's items
        If Not Parent Is Nothing Then
            If Parent.GroupItems.Count > 0 Then
                Parent.GroupItems(1).Selected = True
            End If
        End If
    End If
    End If
End Property

Property Get Tag() As Variant
    If IsObject(m_vTag) Then
        Set Tag = m_vTag
    Else
        Tag = m_vTag
    End If
End Property

Property Let Tag(oValue As Variant)
    m_vTag = oValue
End Property

Property Set Tag(oValue As Variant)
    Set m_vTag = oValue
End Property

Property Get TooltipText() As String
    TooltipText = m_sTooltipText
End Property

Property Let TooltipText(sValue As String)
    m_sTooltipText = sValue
End Property

Friend Property Get Items() As cButtons
    Set Items = m_cItems
End Property

Friend Property Set Items(ByVal oValue As cButtons)
    Set m_cItems = Nothing
End Property

Property Get GroupItems() As cButtons
Attribute GroupItems.VB_UserMemId = 0
    If m_cItems Is Nothing Then
        Set m_cItems = New cButtons
        If Class > 0 Then
            m_cItems.Class = Class - 1
        End If
        Set m_cItems.Parent = Me
    End If
    Set GroupItems = m_cItems
End Property

Public Property Get Class() As UcsButtonClassType
    Class = m_eClass
End Property

Property Let Class(ByVal eValue As UcsButtonClassType)
    m_eClass = eValue
End Property

Public Property Get Parent() As cButton
    Set Parent = m_oParent
End Property

Friend Property Set Parent(ByVal oValue As cButton)
    '--- ToDo: make it a weak reference to Parent
    Set m_oParent = oValue
End Property

Property Get Control() As ctxOutlookBar
    Dim oCtl        As ctxOutlookBar
    
    If Not Parent Is Nothing Then
        Set Control = Parent.Control
    Else
        RaiseEvent GetControl(oCtl)
        Set Control = oCtl
    End If
End Property

Property Get IconsType() As UcsIconStyle
    IconsType = m_eIconsType
End Property

Property Let IconsType(ByVal eValue As UcsIconStyle)
    m_eIconsType = eValue
    pvPaintControl
End Property

Private Sub pvPaintControl()
    On Error Resume Next
    Control.RefreshControl
End Sub

#If DebugMode Then
    Private Sub Class_Initialize()
        DebugInit m_sDebugID, MODULE_NAME
    End Sub
    
    Private Sub Class_Terminate()
        DebugTerm m_sDebugID
    End Sub
#End If
