VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cButtons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'=========================================================================
'
'   You are free to use this source as long as this copyright message
'     appears on your program's "About" dialog:
'
'   Outlook Bar Project
'   Copyright (c) 2002 Vlad Vissoultchev (wqw@geocities.com)
'
'=========================================================================
Option Explicit
Private Const MODULE_NAME As String = "cButtons"

'=========================================================================
' Public enums
'=========================================================================

Public Enum UcsGroupIconsStyle
    ucsGisLargeIcons
    ucsGisSmallIcons
End Enum

'=========================================================================
' Private constants and variables
'=========================================================================

Private m_cItems                As Collection
Private m_hWnd                  As Long
Private m_oParent               As cButton
Private m_eStyle                As UcsGroupIconsStyle
Private m_eClass                As UcsButtonClassType
Private m_bInSet                As Boolean
#If DebugMode Then
    Private m_sDebugID          As String
#End If

'=========================================================================
' Error handling
'=========================================================================

Private Sub RaiseError(sFunc As String)
    PushError sFunc, MODULE_NAME
    PopRaiseError
End Sub

'Private Function ShowError(sFunc As String) As VbMsgBoxResult
'    PushError sFunc, MODULE_NAME
'    ShowError = PopShowError(CAP_MSG)
'End Function

'=========================================================================
' Propeties
'=========================================================================

Property Get Item(IdxOrKey) As cButton
Attribute Item.VB_UserMemId = 0
    Set Item = m_cItems(IdxOrKey)
End Property

Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = m_cItems.[_NewEnum]
End Property

Property Get Count() As Long
    Count = m_cItems.Count
End Property

Friend Property Get Parent() As cButton
    Set Parent = m_oParent
End Property

Friend Property Set Parent(ByVal oValue As cButton)
    Set m_oParent = oValue
End Property

Friend Property Get hwnd() As Long
    hwnd = m_hWnd
End Property

Friend Property Let hwnd(ByVal lValue As Long)
    m_hWnd = lValue
End Property

Property Get Contents() As Byte()
    Const FUNC_NAME     As String = "Contents [get]"
    Dim oBag            As New PropertyBag
    Dim lIdx            As Long
    
    On Error GoTo EH
    With oBag
        .WriteProperty "Cn", Count, 0
        For lIdx = 1 To Count
            With Item(lIdx)
                oBag.WriteProperty "C" & lIdx, .Caption, ""
                oBag.WriteProperty "T" & lIdx, .TooltipText, ""
                oBag.WriteProperty "CL" & lIdx, .Class, ucsBtnClassItem
                oBag.WriteProperty "LI" & lIdx, .LargeIcon, Nothing
                oBag.WriteProperty "SI" & lIdx, .SmallIcon, Nothing
                oBag.WriteProperty "K" & lIdx, .Key, ""
                oBag.WriteProperty "TG" & lIdx, .Tag, Empty
                oBag.WriteProperty "SI" & lIdx, .SmallIcon, Nothing
                oBag.WriteProperty "LI" & lIdx, .LargeIcon, Nothing
                If Not .Items Is Nothing Then
                    oBag.WriteProperty "G" & lIdx, .Items.Contents
                End If
                oBag.WriteProperty "I" & lIdx, .IconsType, ucsIcsSmallIcons
            End With
        Next
        Contents = .Contents
    End With
    Exit Property
EH:
    RaiseError FUNC_NAME
End Property

Property Let Contents(aValue() As Byte)
    Const FUNC_NAME     As String = "Contents [let]"
    Dim oBag            As New PropertyBag
    Dim lIdx            As Long
    
    On Error GoTo EH
    With oBag
        .Contents = aValue
        If Err.Number = 0 Then
            Clear
            m_bInSet = True
            For lIdx = 1 To .ReadProperty("Cn", 0)
                With Add(.ReadProperty("C" & lIdx, ""), _
                            .ReadProperty("LI" & lIdx, Nothing), _
                            .ReadProperty("SI" & lIdx, Nothing), _
                            .ReadProperty("K" & lIdx, ""))
                    Set .Parent = Parent
                    .TooltipText = oBag.ReadProperty("T" & lIdx, "")
                    .Tag = oBag.ReadProperty("TG" & lIdx, Empty)
                    .Class = oBag.ReadProperty("CL" & lIdx, ucsBtnClassItem)
                    Set .SmallIcon = oBag.ReadProperty("SI" & lIdx, Nothing)
                    Set .LargeIcon = oBag.ReadProperty("LI" & lIdx, Nothing)
                    If IsArray(oBag.ReadProperty("G" & lIdx, "")) Then
                        .GroupItems.Contents = oBag.ReadProperty("G" & lIdx)
                    End If
                    .IconsType = oBag.ReadProperty("I" & lIdx, ucsIcsSmallIcons)
                End With
            Next
            m_bInSet = False
            pvRefreshControl
        End If
    End With
    Exit Property
EH:
    RaiseError FUNC_NAME
End Property

Property Get Style() As UcsGroupIconsStyle
    Style = m_eStyle
End Property

Property Let Style(ByVal eValue As UcsGroupIconsStyle)
    m_eStyle = eValue
End Property

Public Property Get Class() As UcsButtonClassType
    Class = m_eClass
End Property

Friend Property Let Class(ByVal eValue As UcsButtonClassType)
    m_eClass = eValue
End Property

'=========================================================================
' Methods
'=========================================================================

Public Function Add( _
            Caption As String, _
            Optional ByVal LargeIcon As StdPicture, _
            Optional ByVal SmallIcon As StdPicture, _
            Optional Key, _
            Optional Before, _
            Optional After) As cButton
    Const FUNC_NAME     As String = "Add"
    
    On Error GoTo EH
    Set Add = New cButton
    Set Add.Parent = Parent
    Add.Class = Class
    Add.Caption = Caption
    Add.TooltipText = Caption
    Set Add.LargeIcon = LargeIcon
    Set Add.SmallIcon = SmallIcon
    If Not IsMissing(Key) Then
        Add.Key = C2Str(Key)
    End If
    If Add.Key <> "" Then
        m_cItems.Add Add, Key, Before, After
    Else
        m_cItems.Add Add, , Before, After
    End If
    If m_cItems.Count = 1 Then
        If Class = ucsBtnClassGroup Then
            Add.Selected = True
        End If
    End If
    pvRefreshControl
    Exit Function
EH:
    RaiseError FUNC_NAME
End Function

Public Sub Remove(IdxOrKey)
    Const FUNC_NAME     As String = "Remove"
    Dim oBtn            As cButton
    Dim lIdx            As Long
    Dim oCtl            As ctxOutlookBar
    
    On Error GoTo EH
    '--- init local vars
    Set oBtn = Item(IdxOrKey)
    lIdx = oBtn.Index
    Set oCtl = oBtn.Control
    '--- clear children
    If Not oBtn.Items Is Nothing Then
        Set oBtn.Items.Parent = Nothing
        oBtn.Items.Clear
        Set oBtn.Items = Nothing
    End If
    '--- disconnect parent
    Set oBtn.Parent = Nothing
    '--- remove from current collection
    m_cItems.Remove IdxOrKey
    '--- fix removed control's selected item/group
    If Not oCtl Is Nothing Then
        If oCtl.SelectedItem Is oBtn Then
            Set oCtl.SelectedItem = Nothing
        End If
        If oCtl.SelectedGroup Is oBtn Then
            If oCtl.Groups.Count >= lIdx Then
                Set oCtl.SelectedGroup = oCtl.Groups(lIdx)
            Else
                If oCtl.Groups.Count > 0 Then
                    Set oCtl.SelectedGroup = oCtl.Groups(lIdx - 1)
                Else
                    Set oCtl.SelectedGroup = Nothing
                End If
            End If
        End If
    End If
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Public Sub Clear()
    Const FUNC_NAME As String = "Remove"
    
    On Error GoTo EH
    Do While m_cItems.Count > 0
        '--- recusevely cleanup
        If Not Item(1).Items Is Nothing Then
            Item(1).Items.Clear
        End If
        Remove 1
    Loop
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Public Function Exists(IdxKeyOrObject) As Boolean
    Dim oItem           As cButton
    
    On Error Resume Next
    If IsObject(IdxKeyOrObject) Then
        For Each oItem In Me
            If oItem Is IdxKeyOrObject Then
                Exit For
            End If
        Next
    Else
        Set oItem = Item(IdxKeyOrObject)
    End If
    '--- success (or failure)
    Exists = Not oItem Is Nothing
End Function

Private Sub pvRefreshControl()
    Const FUNC_NAME     As String = "pvRefreshControl"

    On Error GoTo EH
    If Not m_bInSet Then
        If Not Parent.Control Is Nothing Then
            Parent.Control.RefreshControl
        End If
    End If
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

'=========================================================================
' Class events
'=========================================================================

Private Sub Class_Initialize()
    Set m_cItems = New Collection
    #If DebugMode Then
        DebugInit m_sDebugID, MODULE_NAME
    #End If
End Sub

#If DebugMode Then
    Private Sub Class_Terminate()
        DebugTerm m_sDebugID
    End Sub
#End If

