VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cGradientDef"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'=========================================================================
'
'   You are free to use this source as long as this copyright message
'     appears on your program's "About" dialog:
'
'   Outlook Bar Project
'   Copyright (c) 2002 Vlad Vissoultchev (wqw@geocities.com)
'
'=========================================================================
Option Explicit
Private Const MODULE_NAME As String = "cGradientDef"

'=========================================================================
' Events
'=========================================================================

Event Changed()

'=========================================================================
' Public enums
'=========================================================================

Public Enum UcsGradientType
    ucsGrd_Undefined = -1
    ucsGrdSolid = 0
    ucsGrdHorizontal = 1
    ucsGrdVertical = 2
    ucsGrdBlend = 3
    ucsGrdTransparent = 4
End Enum

'=========================================================================
' Private constants and variables
'=========================================================================

Private Const DEF_GRADIENT_TYPE     As Long = ucsGrdSolid
Private Const DEF_COLOR             As Long = vbButtonFace
Private Const DEF_SECOND_COLOR      As Long = vbButtonFace

Private m_eGradientType         As UcsGradientType
Private m_clrColor              As OLE_COLOR
Private m_clrSecondColor        As OLE_COLOR
#If DebugMode Then
    Private m_sDebugID          As String
#End If

'=========================================================================
' Error handling
'=========================================================================

Private Sub RaiseError(sFunc As String)
    PushError sFunc, MODULE_NAME
    PopRaiseError
End Sub

'=========================================================================
' Propeties
'=========================================================================

Property Get GradientType() As UcsGradientType
    GradientType = m_eGradientType
End Property

Property Let GradientType(ByVal eValue As UcsGradientType)
    m_eGradientType = eValue
    RaiseEvent Changed
End Property

Property Get Color() As OLE_COLOR
    Color = m_clrColor
End Property

Property Let Color(ByVal clrValue As OLE_COLOR)
    m_clrColor = clrValue
    RaiseEvent Changed
End Property

Property Get SecondColor() As OLE_COLOR
    SecondColor = m_clrSecondColor
End Property

Property Let SecondColor(ByVal clrValue As OLE_COLOR)
    m_clrSecondColor = clrValue
    RaiseEvent Changed
End Property

Friend Property Get Contents() As Byte()
    Const FUNC_NAME As String = "Contents [get]"
    
    On Error GoTo EH
    With New PropertyBag
        .WriteProperty "T", GradientType, DEF_GRADIENT_TYPE
        .WriteProperty "C", Color, DEF_COLOR
        .WriteProperty "S", SecondColor, DEF_SECOND_COLOR
        Contents = .Contents
    End With
    Exit Property
EH:
    RaiseError FUNC_NAME
End Property

Friend Property Let Contents(aValue() As Byte)
    Const FUNC_NAME As String = "Contents [let]"

    On Error GoTo EH
    With New PropertyBag
        .Contents = aValue
        GradientType = .ReadProperty("T", DEF_GRADIENT_TYPE)
        Color = .ReadProperty("C", DEF_COLOR)
        SecondColor = .ReadProperty("S", DEF_SECOND_COLOR)
    End With
    Exit Property
EH:
    RaiseError FUNC_NAME
End Property

'=========================================================================
' Class events
'=========================================================================

Private Sub Class_Initialize()
    On Error Resume Next
    GradientType = DEF_GRADIENT_TYPE
    Color = DEF_COLOR
    SecondColor = DEF_SECOND_COLOR
    #If DebugMode Then
        DebugInit m_sDebugID, MODULE_NAME
    #End If
End Sub

#If DebugMode Then
    Private Sub Class_Terminate()
        DebugTerm m_sDebugID
    End Sub
#End If

