VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMemDC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'=========================================================================
'
'   You are free to use this source as long as this copyright message
'     appears on your program's "About" dialog:
'
'   Outlook Bar Project
'   Copyright (c) 2002 Vlad Vissoultchev (wqw@geocities.com)
'
'=========================================================================
Option Explicit

'=========================================================================
' Public enums
'=========================================================================

Public Enum UcsBackStyles
    BS_TRANSPARENT = 1
    BS_OPAQUE = 2
    BS_NEWTRANSPARENT = 3
End Enum

Public Enum UcsDrawTextStyles
    DT_LEFT = &H0
    DT_TOP = &H0
    DT_CENTER = &H1
    DT_RIGHT = &H2
    DT_VCENTER = &H4
    DT_BOTTOM = &H8
    DT_WORDBREAK = &H10
    DT_SINGLELINE = &H20
    DT_EXPANDTABS = &H40
    DT_TABSTOP = &H80
    DT_NOCLIP = &H100
    DT_EXTERNALLEADING = &H200
    DT_CALCRECT = &H400
    DT_NOPREFIX = &H800
    DT_INTERNAL = &H1000
    '#if(WINVER >= 0x0400)
    DT_EDITCONTROL = &H2000
    DT_PATH_ELLIPSIS = &H4000
    DT_END_ELLIPSIS = &H8000
    DT_MODIFYSTRING = &H10000
    DT_RTLREADING = &H20000
    DT_WORD_ELLIPSIS = &H40000
End Enum

Public Enum UcsBorderStyles
    BDR_RAISEDOUTER = &H1
    BDR_SUNKENOUTER = &H2
    BDR_RAISEDINNER = &H4
    BDR_SUNKENINNER = &H8
    BDR_OUTER = (BDR_RAISEDOUTER Or BDR_SUNKENOUTER)
    BDR_INNER = (BDR_RAISEDINNER Or BDR_SUNKENINNER)
    EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
    EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
    EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
    EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
End Enum

Public Enum UcsBorderFlags
    BF_LEFT = &H1
    BF_TOP = &H2
    BF_RIGHT = &H4
    BF_BOTTOM = &H8
    BF_TOPLEFT = (BF_TOP Or BF_LEFT)
    BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
    BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
    BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
    BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
    BF_DIAGONAL = &H10
End Enum

Public Enum UcsExtTextOutStyles
    ETO_GRAYED = 1
    ETO_OPAQUE = 2
    ETO_CLIPPED = 4
End Enum

'=========================================================================
' API
'=========================================================================

'--- GetTextMetrics constants
Private Const FW_NORMAL                 As Long = 400
Private Const LF_FACESIZE               As Long = 32
Private Const CLIP_DEFAULT_PRECIS       As Long = 0
Private Const OUT_DEFAULT_PRECIS        As Long = 0
Private Const DEFAULT_PITCH             As Long = 0
Private Const DEFAULT_QUALITY           As Long = 0
'--- GetDeviceCaps constants
Private Const RASTERCAPS                As Long = 38
Private Const LOGPIXELSX                As Long = 88
Private Const LOGPIXELSY                As Long = 90
Private Const SIZEPALETTE               As Long = 104
Private Const RC_PALETTE                As Long = &H100
Private Const CAPS1                     As Long = 94 ' other caps
Private Const C1_TRANSPARENT            As Long = &H1 ' new raster cap
'--- GetStockObject constants
Private Const DKGRAY_BRUSH              As Long = 3
'--- DrawIconEx constants
Private Const DI_NORMAL                 As Long = &H3
'--- DIB Section constants
Private Const BI_RGB                    As Long = 0
Private Const DIB_RGB_COLORS            As Long = 0 '  color table in RGBs
Private Const DIB_PAL_COLORS            As Long = 1
Private Const DIB_PAL_INDICES           As Long = 2
'--- Raster Operation Codes
Private Const DSna                      As Long = &H220326
'--- createpen constants
Private Const PS_SOLID                  As Long = 0
'--- gradient fill
Private Const GRADIENT_FILL_RECT_H      As Long = 0
Private Const GRADIENT_FILL_RECT_V      As Long = 1
'--- brush style
Private Const BS_NULL                   As Long = 1
Private Const BS_HATCHED                As Long = 2
Private Const BS_HOLLOW                 As Long = BS_NULL

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
'Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function ApiDrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hDC As Long, ByVal lpsz As String, ByVal n As Long, lpRect As RECT, ByVal un As Long, lpDrawTextParams As DRAWTEXTPARAMS) As Long
Private Declare Function GetBkMode Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function GetTextFace Lib "gdi32" Alias "GetTextFaceA" (ByVal hDC As Long, ByVal nCount As Long, ByVal lpFacename As String) As Long
Private Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" (ByVal hDC As Long, lpMetrics As TEXTMETRIC) As Long
Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hDC As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function RealizePalette Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function ApiDeleteObject Lib "gdi32" Alias "DeleteObject" (ByVal hObject As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function ApiFillRect Lib "user32" Alias "FillRect" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function ApiBitBlt Lib "gdi32" Alias "BitBlt" (ByVal hdcDest As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (lpPictDesc As PICTDESC, riid As Any, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateEnhMetaFileLong Lib "gdi32" Alias "CreateEnhMetaFileA" (ByVal hdcRef As Long, ByVal lpFileName As String, ByVal lpRect As Long, ByVal lpDescription As String) As Long
Private Declare Function CloseEnhMetaFile Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteEnhMetaFile Lib "gdi32" (ByVal hEmf As Long) As Long
Private Declare Function PlayMetaFile Lib "gdi32" (ByVal hDC As Long, ByVal hMF As Long) As Long
Private Declare Function PlayEnhMetaFile Lib "gdi32" (ByVal hDC As Long, ByVal hEmf As Long, lpRect As RECT) As Long
Private Declare Function DrawIconEx Lib "user32" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function CreatePatternBrush Lib "gdi32" (ByVal hBitmap As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function CreateIconIndirect Lib "user32" (piconinfo As ICONINFO) As Long
Private Declare Function GetTextExtentPoint Lib "gdi32" Alias "GetTextExtentPointA" (ByVal hDC As Long, ByVal lpszString As String, ByVal cbString As Long, lpSize As SIZEAPI) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long
Private Declare Function CreateHalftonePalette Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, ByVal lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function SetDIBColorTable Lib "gdi32" (ByVal hDC As Long, ByVal un1 As Long, ByVal un2 As Long, pcRGBQuad As RGBQUAD) As Long
Private Declare Function SetMapMode Lib "gdi32" (ByVal hDC As Long, ByVal nMapMode As Long) As Long
Private Declare Function GetMapMode Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpPoint As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function ApiDrawEdge Lib "user32" Alias "DrawEdge" (ByVal hDC As Long, qrc As RECT, ByVal Edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function ApiExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, ByVal lpDx As Long) As Long
Private Declare Function SelectClipRgn Lib "gdi32" (ByVal hDC As Long, ByVal hrgn As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function GradientFill Lib "Msimg32.dll" (ByVal hDC As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long
Private Declare Function ApiFrameRect Lib "user32" Alias "FrameRect" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function StretchDIBits Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long
Private Declare Function ApiArc Lib "gdi32" Alias "Arc" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long, ByVal X4 As Long, ByVal Y4 As Long) As Long
Private Declare Function SetROP2 Lib "gdi32" (ByVal hDC As Long, ByVal nDrawMode As Long) As Long
Private Declare Function GetROP2 Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function ApiEllipse Lib "gdi32" Alias "Ellipse" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateBrushIndirect Lib "gdi32" (lpLogBrush As LOGBRUSH) As Long
Private Declare Function ApiGetPixel Lib "gdi32" Alias "GetPixel" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function ApiSetPixel Lib "gdi32" Alias "SetPixel" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Type POINTAPI
    X                   As Long
    Y                   As Long
End Type

Private Type SIZEAPI
    cx                  As Long
    cy                  As Long
End Type

Private Type RECT
    Left                As Long
    Top                 As Long
    Right               As Long
    Bottom              As Long
End Type

Private Type LOGFONT
    lfHeight            As Long
    lfWidth             As Long
    lfEscapement        As Long
    lfOrientation       As Long
    lfWeight            As Long
    lfItalic            As Byte
    lfUnderline         As Byte
    lfStrikeOut         As Byte
    lfCharSet           As Byte
    lfOutPrecision      As Byte
    lfClipPrecision     As Byte
    lfQuality           As Byte
    lfPitchAndFamily    As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Type DRAWTEXTPARAMS
    cbSize              As Long
    iTabLength          As Long
    iLeftMargin         As Long
    iRightMargin        As Long
    uiLengthDrawn       As Long
End Type

Private Type TEXTMETRIC
    tmHeight            As Long
    tmAscent            As Long
    tmDescent           As Long
    tmInternalLeading   As Long
    tmExternalLeading   As Long
    tmAveCharWidth      As Long
    tmMaxCharWidth      As Long
    tmWeight            As Long
    tmOverhang          As Long
    tmDigitizedAspectX  As Long
    tmDigitizedAspectY  As Long
    tmFirstChar         As Byte
    tmLastChar          As Byte
    tmDefaultChar       As Byte
    tmBreakChar         As Byte
    tmItalic            As Byte
    tmUnderlined        As Byte
    tmStruckOut         As Byte
    tmPitchAndFamily    As Byte
    tmCharSet           As Byte
End Type

Private Type PALETTEENTRY
    peRed               As Byte
    peGreen             As Byte
    peBlue              As Byte
    peFlags             As Byte
End Type

Private Type LOGPALETTE
    palVersion          As Integer
    palNumEntries       As Integer
    palPalEntry(255)    As PALETTEENTRY
End Type

Private Type PICTDESC
    Size                As Long
    Type                As Long
    hBmpOrIcon          As Long
    hPal                As Long
End Type

Private Type LOGBRUSH
    lbStyle             As Long
    lbColor             As Long
    lbHatch             As Long
End Type

Private Type ICONINFO
    fIcon               As Long
    xHotspot            As Long
    yHotspot            As Long
    hbmMask             As Long
    hbmColor            As Long
End Type

Private Type BITMAPINFOHEADER '40 bytes
    biSize              As Long
    biWidth             As Long
    biHeight            As Long
    biPlanes            As Integer
    biBitCount          As Integer
    biCompression       As Long
    biSizeImage         As Long
    biXPelsPerMeter     As Long
    biYPelsPerMeter     As Long
    biClrUsed           As Long
    biClrImportant      As Long
End Type

Private Type RGBQUAD
    rgbBlue             As Byte
    rgbGreen            As Byte
    rgbRed              As Byte
    rgbReserved         As Byte
End Type

Private Type BITMAPINFO
    bmiHeader           As BITMAPINFOHEADER
    bmiColors(1)        As RGBQUAD
End Type

Private Type TRIVERTEX
    X                   As Long
    Y                   As Long
    Red                 As Integer
    Green               As Integer
    Blue                As Integer
    Alpha               As Integer
End Type

Private Type GRADIENT_RECT
    UpperLeft           As Long
    LowerRight          As Long
End Type

'=========================================================================
' Member variables and constants
'=========================================================================

Private Const MASK_COLOR                As Long = &HFF00FF

Private m_MemoryDC              As Long ' DC handle of the created Device Context
Private m_MemoryWidth           As Long ' Width of the bitmap
Private m_MemoryHeight          As Long ' Height of the bitmap
Private m_MemoryBitmap          As Long ' Handle of the created bitmap
Private m_OrginalBitmap         As Long ' Used in Destroy
Private m_MemoryPal             As Long ' Handle of the created palette
Private m_OrginalPal            As Long ' Used in Destroy
Private m_MemoryFont            As Long ' Font handle in use (last set)
Private m_OrginalFont           As Long ' Previously selected font
Private m_ParentDC              As Long ' Used in Copy method as default value
Private m_MemoryBrush           As Long
Private m_OriginalBrush         As Long
Private m_MemoryPen             As Long
Private m_OriginalPen           As Long
Private m_hDotBrush             As Long
Private m_hDotBitmap            As Long

'=========================================================================
' Properties
'=========================================================================

Public Property Get hDC() As Long
    hDC = m_MemoryDC
End Property

Public Property Get Width() As Long
    Width = m_MemoryWidth
End Property

Public Property Get Height() As Long
    Height = m_MemoryHeight
End Property

Public Property Get FontHeight() As Long
    Dim tm As TEXTMETRIC
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    GetTextMetrics m_MemoryDC, tm
    FontHeight = tm.tmHeight
End Property

Public Property Get Font() As StdFont
    Dim tm              As TEXTMETRIC
    Dim sFaceName       As String * 80

    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    GetTextMetrics m_MemoryDC, tm
    GetTextFace m_MemoryDC, 79, sFaceName
    Set Font = New StdFont
    With Font
        .Bold = (tm.tmWeight > FW_NORMAL)
        .Charset = tm.tmCharSet
        .Italic = (tm.tmItalic <> 0)
        .Name = sFaceName 'StrConv(sFaceName, vbUnicode)
        .Strikethrough = (tm.tmStruckOut <> 0)
        .Underline = (tm.tmUnderlined <> 0)
        .Weight = tm.tmWeight
        .Size = (tm.tmHeight * 72) / tm.tmDigitizedAspectY  ' Size has to be calculated
    End With
End Property

Public Property Set Font(ByVal NewFont As StdFont)
    Dim nName()         As Byte
    Dim i               As Byte
    Dim nSize           As Byte
    Dim tFont           As LOGFONT

    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    ' Font name is a byte array and is in ANSI (DOS) format (1 byte = 1 character)
    nName = StrConv(NewFont.Name & Chr$(0), vbFromUnicode)
    nSize = UBound(nName)
    If nSize > LF_FACESIZE Then nSize = LF_FACESIZE
    For i = 0 To nSize
        tFont.lfFaceName(i) = nName(i)
    Next

    With tFont
        .lfCharSet = NewFont.Charset
        .lfClipPrecision = CLIP_DEFAULT_PRECIS
        .lfEscapement = 0                       ' Angle to print
        .lfOrientation = .lfEscapement
        .lfWidth = 0#
        .lfItalic = IIf(NewFont.Italic, 1, 0)
        .lfOutPrecision = OUT_DEFAULT_PRECIS
        .lfPitchAndFamily = DEFAULT_PITCH
        .lfQuality = DEFAULT_QUALITY
        .lfStrikeOut = IIf(NewFont.Strikethrough, 1, 0)
        .lfUnderline = IIf(NewFont.Underline, 1, 0)
        .lfWeight = NewFont.Weight
        ' Font size (height) has to be calculated
        .lfHeight = -Fix(NewFont.Size * GetDeviceCaps(m_MemoryDC, LOGPIXELSY) / 72)
    End With

    ' Set environment (remember previous settings)
    If m_MemoryFont <> 0 Then
        ' Reset environment
        Call SelectObject(m_MemoryDC, m_OrginalFont)
        Call ApiDeleteObject(m_MemoryFont)
    End If
    m_MemoryFont = CreateFontIndirect(tFont)
    m_OrginalFont = SelectObject(m_MemoryDC, m_MemoryFont)
End Property

Public Property Get ForeColor() As Long
    If IsCreated() Then
        ForeColor = GetTextColor(m_MemoryDC)
    End If
End Property

Public Property Let ForeColor(ByVal NewValue As Long)
    If IsCreated() Then
        SetTextColor m_MemoryDC, TranslateColor(NewValue)
    End If
End Property

Public Property Get BackColor() As Long
    If IsCreated() Then
        BackColor = GetBkColor(m_MemoryDC)
    End If
End Property

Public Property Let BackColor(ByVal NewValue As Long)
    If IsCreated() Then
        SetBkColor m_MemoryDC, TranslateColor(NewValue)
    End If
End Property

Public Property Get BackStyle() As UcsBackStyles
    If IsCreated() Then
        BackStyle = GetBkMode(m_MemoryDC)
    End If
End Property

Public Property Let BackStyle(ByVal NewValue As UcsBackStyles)
    If IsCreated() Then
        SetBkMode m_MemoryDC, NewValue
    End If
End Property

Public Property Get DotBrush() As Long
    Dim waBits(0 To 3)  As Long
        
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    If m_hDotBrush = 0 Then
        '--- fill pattern array
        waBits(0) = &H5555AAAA
        waBits(1) = &H5555AAAA
        waBits(2) = &H5555AAAA
        waBits(3) = &H5555AAAA
        '--- create pattern brush
        m_hDotBitmap = CreateBitmap(8, 8, 1, 1, waBits(0))
        If m_hDotBitmap <> 0 Then
            m_hDotBrush = CreatePatternBrush(m_hDotBitmap)
            ApiDeleteObject m_hDotBitmap
            m_hDotBitmap = 0
        End If
        '--- default to darkgray brush
        If m_hDotBrush = 0 Then
            m_hDotBrush = GetStockObject(DKGRAY_BRUSH)
        End If
    End If
    '--- success
    DotBrush = m_hDotBrush
End Property

Public Property Get Brush() As Long
    Brush = m_MemoryBrush
End Property

Public Property Let Brush(ByVal lValue As Long)
    Dim hPrevBrush      As Long
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    If lValue <> 0 Then
        '--- set new brush (and save original)
        hPrevBrush = SelectObject(m_MemoryDC, lValue)
        If m_OriginalBrush = 0 Then
            m_OriginalBrush = hPrevBrush
        End If
    ElseIf m_OriginalBrush <> 0 Then
        '--- restore original brush
        hPrevBrush = SelectObject(m_MemoryDC, m_OriginalBrush)
        m_OriginalBrush = 0
    End If
    '--- delete if previously selected
    If m_MemoryBrush = hPrevBrush And hPrevBrush <> m_hDotBrush Then
        Call ApiDeleteObject(hPrevBrush)
    End If
    '--- success
    m_MemoryBrush = lValue
End Property

Public Property Get Pen() As Long
    Pen = m_MemoryPen
End Property

Public Property Let Pen(ByVal lValue As Long)
    Dim hPrevPen      As Long
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    If lValue <> 0 Then
        '--- set new pen (and save original)
        hPrevPen = SelectObject(m_MemoryDC, lValue)
        If m_OriginalPen = 0 Then
            m_OriginalPen = hPrevPen
        End If
    ElseIf m_OriginalPen <> 0 Then
        '--- restore original pen
        hPrevPen = SelectObject(m_MemoryDC, m_OriginalPen)
        m_OriginalPen = 0
    End If
    '--- delete if previously selected
    If m_MemoryPen = hPrevPen Then
        Call ApiDeleteObject(hPrevPen)
    End If
    '--- success
    m_MemoryPen = lValue
End Property

Public Property Get Image() As StdPicture
    Dim hdcPaint            As Long
    Dim hbmPaint            As Long
    Dim hbmPaintOrig        As Long
    Dim hpalPaintOrig       As Long
    
    '--- state check
    If Not IsCreated() Then
        Exit Property
    End If
    '--- prepare
    hdcPaint = CreateCompatibleDC(m_MemoryDC)
    hbmPaint = CreateCompatibleBitmap(m_MemoryDC, m_MemoryWidth, m_MemoryHeight)
    hbmPaintOrig = SelectObject(hdcPaint, hbmPaint)
    If m_MemoryPal <> 0 Then
        hpalPaintOrig = SelectPalette(hdcPaint, m_MemoryPal, 0)
        Call RealizePalette(hdcPaint)
    End If
    '--- bitblit
    Call ApiBitBlt(hdcPaint, 0, 0, m_MemoryWidth, m_MemoryHeight, m_MemoryDC, 0, 0, vbSrcCopy)
    '--- deselect
    Call SelectObject(hdcPaint, hbmPaintOrig)
    If hpalPaintOrig <> 0 Then
        Call SelectPalette(hdcPaint, hpalPaintOrig, 0)
        Call RealizePalette(hdcPaint)
    End If
    Call DeleteDC(hdcPaint)
    '--- get image
    Set Image = pvBitmapToPicture(hbmPaint, m_MemoryPal)
End Property

Property Get IsMemoryDC() As Boolean
    IsMemoryDC = (m_MemoryBitmap <> 0)
End Property

Property Get DrawMode() As DrawModeConstants
    If IsCreated() Then
        DrawMode = GetROP2(m_MemoryDC)
    End If
End Property

Property Let DrawMode(ByVal dwValue As DrawModeConstants)
    If IsCreated() Then
        Call SetROP2(m_MemoryDC, dwValue)
    End If
End Property

'=========================================================================
' Methods
'=========================================================================

Public Function Init( _
            Optional PixelWidth As Long, _
            Optional PixelHeight As Long, _
            Optional hParentDC As Long, _
            Optional hMemoryDC As Long) As Long
    Dim nHasPalette         As Long
    Dim nPaletteSize        As Long
    Dim LogPal              As LOGPALETTE
    Dim tm                  As TEXTMETRIC
    Dim sFaceName           As String * 80
    Dim fFont               As StdFont

    If IsCreated() Then
        Destroy
    End If
    '--- local vars
    m_MemoryWidth = PixelWidth
    m_MemoryHeight = PixelHeight
    '--- check if parent dc supplied
    If hParentDC = 0 Then
        m_ParentDC = GetDC(0)
    Else
        m_ParentDC = hParentDC
    End If
    '--- check if dc already supplied
    If hMemoryDC = 0 Then
        ' Create a memory device context to use
        m_MemoryDC = CreateCompatibleDC(m_ParentDC)
        ' Tell'em it's a picture (so drawings can be done on the DC)
        m_MemoryBitmap = CreateCompatibleBitmap(m_ParentDC, m_MemoryWidth, m_MemoryHeight)
        m_OrginalBitmap = SelectObject(m_MemoryDC, m_MemoryBitmap)
    Else
        m_MemoryDC = hMemoryDC
        m_MemoryBitmap = 0
    End If
    ' Get screen properties
    nHasPalette = GetDeviceCaps(m_ParentDC, RASTERCAPS) And RC_PALETTE   ' Palette support
    nPaletteSize = GetDeviceCaps(m_ParentDC, SIZEPALETTE)                ' Size of palette
    ' If the screen has a palette make a copy and realize it
    If nHasPalette And (nPaletteSize = 256) Then
        ' Create a copy of the system palette
        LogPal.palVersion = &H300
        LogPal.palNumEntries = 256
        Call GetSystemPaletteEntries(m_ParentDC, 0&, 256, LogPal.palPalEntry(0))
        m_MemoryPal = CreatePalette(LogPal)
        ' Select the new palette into the memory DC and realize it
        m_OrginalPal = SelectPalette(m_MemoryDC, m_MemoryPal, 0&)
        Call RealizePalette(m_MemoryDC)
    End If

    ' Set attributes. Take from parent.
    Call SetBkColor(m_MemoryDC, GetBkColor(m_ParentDC))
    Call SetTextColor(m_MemoryDC, GetTextColor(m_ParentDC))
    Call SetBkMode(m_MemoryDC, GetBkMode(m_ParentDC))

    Call GetTextMetrics(m_ParentDC, tm)
    Call GetTextFace(m_ParentDC, 79, sFaceName)
    Set fFont = New StdFont
    With fFont
        .Bold = (tm.tmWeight > FW_NORMAL)
        .Charset = tm.tmCharSet
        .Italic = (tm.tmItalic <> 0)
        .Name = sFaceName
        .Strikethrough = (tm.tmStruckOut <> 0)
        .Underline = (tm.tmUnderlined <> 0)
        .Weight = tm.tmWeight
        .Size = (tm.tmHeight / tm.tmDigitizedAspectY) * 72 ' Size has to be calculated
    End With
    Set Font = fFont
    Set fFont = Nothing
    If hParentDC = 0 Then
        ReleaseDC 0, m_ParentDC
        m_ParentDC = 0
    End If
    '--- success
    Init = m_MemoryDC
End Function

Public Sub Destroy()
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- deselect objects
    If m_OriginalPen <> 0 Then
        Call SelectObject(m_MemoryDC, m_OriginalPen)
        m_OriginalPen = 0
    End If
    If m_OriginalBrush <> 0 Then
        Call SelectObject(m_MemoryDC, m_OriginalBrush)
        m_OriginalBrush = 0
    End If
    If m_OrginalPal <> 0 Then
        Call SelectPalette(m_MemoryDC, m_OrginalPal, 0&)
        Call RealizePalette(m_MemoryDC)
        m_OrginalPal = 0
    End If
    If m_OrginalBitmap <> 0 Then
        Call SelectObject(m_MemoryDC, m_OrginalBitmap)
        m_OrginalBitmap = 0
    End If
    If m_OrginalFont <> 0 Then
        Call SelectObject(m_MemoryDC, m_OrginalFont)
        m_OrginalFont = 0
    End If
    '--- delete objects
    If m_MemoryPen <> 0 Then
        Call ApiDeleteObject(m_MemoryPen)
        m_MemoryPen = 0
    End If
    If m_MemoryBrush <> 0 Then
        Call ApiDeleteObject(m_MemoryBrush)
        m_MemoryBrush = 0
    End If
    If m_hDotBrush <> 0 Then
        Call ApiDeleteObject(m_hDotBrush)
        m_hDotBrush = 0
        If m_hDotBitmap <> 0 Then
            Call ApiDeleteObject(m_hDotBitmap)
            m_hDotBitmap = 0
        End If
    End If
    If m_MemoryFont <> 0 Then
        Call ApiDeleteObject(m_MemoryFont)
        m_MemoryFont = 0
    End If
    If m_MemoryPal <> 0 Then
        Call ApiDeleteObject(m_MemoryPal)
        m_MemoryPal = 0
    End If
    If m_MemoryBitmap <> 0 Then
        Call ApiDeleteObject(m_MemoryBitmap)
        m_MemoryBitmap = 0
        If m_MemoryDC <> 0 Then
            Call DeleteDC(m_MemoryDC)
            m_MemoryDC = 0
        End If
    End If
End Sub

Public Function IsCreated() As Boolean
    IsCreated = (m_MemoryDC <> 0)
End Function

Public Sub Cls( _
            Optional ByVal clrFill As Long = -1, _
            Optional ByVal hbrFill As Long)
    FillRect 0, 0, Width, Height, clrFill, hbrFill
End Sub

Public Sub FillRect( _
            Optional ByVal LeftX As Long, _
            Optional ByVal TopY As Long, _
            Optional ByVal RightX As Long = -1, _
            Optional ByVal BottomY As Long = -1, _
            Optional ByVal clrFill As Long = -1, _
            Optional ByVal hbrFill As Long)
    Dim rc          As RECT

    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- create brush if neccessary
    If clrFill <> -1 Then
        hbrFill = CreateSolidBrush(TranslateColor(clrFill))
    End If
    With rc
        .Left = LeftX
        .Top = TopY
        .Right = IIf(RightX < LeftX, Width, RightX)
        .Bottom = IIf(BottomY < TopY, Height, BottomY)
    End With
    Call ApiFillRect(m_MemoryDC, rc, hbrFill)
    '--- cleanup the brush (if neccessary)
    If clrFill <> -1 Then
        Call ApiDeleteObject(hbrFill)
    End If
End Sub

Public Sub FillGradient( _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            ByVal clrFirst As OLE_COLOR, _
            ByVal clrSecond As OLE_COLOR, _
            Optional ByVal bVertical As Boolean)
    Dim pVert(0 To 1)   As TRIVERTEX
    Dim clr             As OLE_COLOR
    Dim pGradRect       As GRADIENT_RECT
    
    clr = TranslateColor(clrFirst)
    With pVert(0)
        .X = LeftX
        .Y = TopY
        .Red = pvRed(clr)
        .Green = pvGreen(clr)
        .Blue = pvBlue(clr)
    End With
    clr = TranslateColor(clrSecond)
    With pVert(1)
        .X = RightX
        .Y = BottomY
        .Red = pvRed(clr)
        .Green = pvGreen(clr)
        .Blue = pvBlue(clr)
    End With
    With pGradRect
        .UpperLeft = 0
        .LowerRight = 1
    End With
    GradientFill m_MemoryDC, pVert(0), 2, pGradRect, 1, _
                IIf(Not bVertical, GRADIENT_FILL_RECT_H, GRADIENT_FILL_RECT_V)
End Sub

Private Function pvRed(ByVal clr As OLE_COLOR) As Long
    pvRed = ((clr \ &H1) And &HFF) * &H100&
    If pvRed >= &H8000& Then
        pvRed = pvRed - &H10000
    End If
End Function
    
Private Function pvGreen(ByVal clr As OLE_COLOR) As Long
    pvGreen = ((clr \ &H100) And &HFF) * &H100&
    If pvGreen >= &H8000& Then
        pvGreen = pvGreen - &H10000
    End If
End Function

Private Function pvBlue(ByVal clr As OLE_COLOR) As Long
    pvBlue = ((clr \ &H10000) And &HFF) * &H100&
    If pvBlue >= &H8000& Then
        pvBlue = pvBlue - &H10000
    End If
End Function

Public Sub DrawEdge( _
            Optional ByVal LeftX As Long, _
            Optional ByVal TopY As Long, _
            Optional ByVal RightX As Long = -1, _
            Optional ByVal BottomY As Long = -1, _
            Optional ByVal Edge As UcsBorderStyles = BDR_SUNKENOUTER, _
            Optional ByVal Flags As UcsBorderFlags = BF_RECT)
    Dim rc          As RECT
    
    rc.Left = LeftX
    rc.Top = TopY
    rc.Right = IIf(RightX < LeftX, Width, RightX)
    rc.Bottom = IIf(BottomY < TopY, Height, BottomY)
    ApiDrawEdge m_MemoryDC, rc, Edge, Flags
End Sub

Public Sub FrameRect( _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            Optional ByVal clrFill As Long = -1, _
            Optional ByVal hbrFill As Long)
    Dim rc          As RECT

    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- create brush if neccessary
    If clrFill <> -1 Then
        hbrFill = CreateSolidBrush(TranslateColor(clrFill))
    End If
    With rc
        .Left = LeftX
        .Top = TopY
        .Right = RightX
        .Bottom = BottomY
    End With
    Call ApiFrameRect(m_MemoryDC, rc, hbrFill)
    '--- cleanup the brush (if neccessary)
    If clrFill <> -1 Then
        Call ApiDeleteObject(hbrFill)
    End If
End Sub

Public Sub DrawLine( _
            ByVal X1 As Long, _
            ByVal Y1 As Long, _
            ByVal X2 As Long, _
            ByVal Y2 As Long, _
            Optional ByVal clrLine As Long = -1, _
            Optional ByVal hpnLine As Long)
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- create pen if neccessary
    If clrLine <> -1 Then
        hpnLine = CreatePen(PS_SOLID, 1, TranslateColor(clrLine))
    End If
    Pen = hpnLine
    '--- draw line
    If X1 >= 0 Then
        MoveToEx m_MemoryDC, X1, Y1, 0
    End If
    LineTo m_MemoryDC, X2, Y2
End Sub

Public Sub BitBlt( _
            Optional ByVal hdcDest As Long, _
            Optional ByVal xDest As Long, _
            Optional ByVal yDest As Long, _
            Optional ByVal nWidth As Long, _
            Optional ByVal nHeight As Long, _
            Optional ByVal xSrc As Long, _
            Optional ByVal ySrc As Long, _
            Optional ByVal dwRop As RasterOpConstants = vbSrcCopy)
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- fix arguments
    If hdcDest = 0 Then
        hdcDest = m_ParentDC
    End If
    If nWidth = 0 Then
        nWidth = m_MemoryWidth
    End If
    If nHeight = 0 Then
        nHeight = m_MemoryHeight
    End If
    Call ApiBitBlt(hdcDest, xDest, yDest, nWidth, nHeight, m_MemoryDC, xSrc, ySrc, dwRop)
End Sub

Public Sub TransBlt( _
            Optional ByVal hdcDest As Long, _
            Optional ByVal xDest As Long, _
            Optional ByVal yDest As Long, _
            Optional ByVal nWidth As Long, _
            Optional ByVal nHeight As Long, _
            Optional ByVal xSrc As Long, _
            Optional ByVal ySrc As Long, _
            Optional ByVal clrMask As OLE_COLOR = MASK_COLOR)
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- fix arguments
    If hdcDest = 0 Then
        hdcDest = m_ParentDC
    End If
    If nWidth = 0 Then
        nWidth = m_MemoryWidth
    End If
    If nHeight = 0 Then
        nHeight = m_MemoryHeight
    End If
    pvTransBlt hdcDest, xDest, yDest, nWidth, nHeight, m_MemoryDC, xSrc, ySrc, TranslateColor(clrMask)
End Sub

Private Sub pvTransBltOld( _
            ByVal hdcDest As Long, _
            ByVal xDest As Long, _
            ByVal yDest As Long, _
            ByVal nWidth As Long, _
            ByVal nHeight As Long, _
            ByVal hdcSrc As Long, _
            ByVal xSrc As Long, _
            ByVal ySrc As Long, _
            ByVal clrMask As Long)
    '
    ' 32-Bit Transparent ApiBitBlt Function
    ' Written by Karl E. Peterson, 9/20/96.
    ' Portions borrowed and modified from KB.
    ' Other portions modified following input from users. <g>
    '
    ' Parameters ************************************************************
    ' hdcDest: Destination device context
    ' x, y: Upper-left destination coordinates (pixels)
    ' nWidth: Width of destination
    ' nHeight: Height of destination
    ' hdcSrc: Source device context
    ' xSrc, ySrc: Upper-left source coordinates (pixels)
    ' clrMask: RGB value for transparent pixels, typically &HC0C0C0.
    ' ***********************************************************************
    '
    Dim OrigColor As Long ' Holds original background color
    Dim OrigMode As Long ' Holds original background drawing mode
     
    If (GetDeviceCaps(hdcDest, CAPS1) And C1_TRANSPARENT) Then
        '
        ' Some NT machines support this *super* simple method!
        ' Save original settings, Blt, restore settings.
        '
        OrigMode = SetBkMode(hdcDest, BS_NEWTRANSPARENT)
        OrigColor = SetBkColor(hdcDest, clrMask)
        Call ApiBitBlt(hdcDest, xDest, yDest, nWidth, nHeight, hdcSrc, xSrc, ySrc, vbSrcCopy)
        Call SetBkColor(hdcDest, OrigColor)
        Call SetBkMode(hdcDest, OrigMode)
    Else
        Dim saveDC          As Long ' Backup copy of source bitmap
        Dim maskDC          As Long ' Mask bitmap (monochrome)
        Dim invDC           As Long ' Inverse of mask bitmap (monochrome)
        Dim resultDC        As Long ' Combination of source bitmap & background
        Dim screenDC        As Long
        Dim hSaveBmp        As Long ' Bitmap stores backup copy of source bitmap
        Dim hMaskBmp        As Long ' Bitmap stores mask (monochrome)
        Dim hInvBmp         As Long ' Bitmap holds inverse of mask (monochrome)
        Dim hResultBmp      As Long ' Bitmap combination of source & background
        Dim hSavePrevBmp    As Long ' Holds previous bitmap in saved DC
        Dim hMaskPrevBmp    As Long ' Holds previous bitmap in the mask DC
        Dim hInvPrevBmp     As Long ' Holds previous bitmap in inverted mask DC
        Dim hDestPrevBmp    As Long ' Holds previous bitmap in destination DC
        '
        ' Create DCs to hold various stages of transformation.
        '
        screenDC = GetDC(0)
        saveDC = CreateCompatibleDC(screenDC)
        maskDC = CreateCompatibleDC(screenDC)
        invDC = CreateCompatibleDC(screenDC)
        resultDC = CreateCompatibleDC(screenDC)
        '
        ' Create monochrome bitmaps for the mask-related bitmaps.
        '
        hMaskBmp = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
        hInvBmp = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
        '
        ' Create color bitmaps for final result & stored copy of source.
        '
        hResultBmp = CreateCompatibleBitmap(hdcDest, nWidth, nHeight)
        hSaveBmp = CreateCompatibleBitmap(hdcDest, nWidth, nHeight)
        '
        ' Select bitmaps into DCs.
        '
        hSavePrevBmp = SelectObject(saveDC, hSaveBmp)
        hMaskPrevBmp = SelectObject(maskDC, hMaskBmp)
        hInvPrevBmp = SelectObject(invDC, hInvBmp)
        hDestPrevBmp = SelectObject(resultDC, hResultBmp)
        '
        ' Create mask: set background color of source to transparent color.
        '
        OrigColor = SetBkColor(hdcSrc, clrMask)
        Call ApiBitBlt(maskDC, 0, 0, nWidth, nHeight, hdcSrc, xSrc, ySrc, vbSrcCopy)
        clrMask = SetBkColor(hdcSrc, OrigColor)
        '
        ' Create inverse of mask to AND w/ source & combine w/ background.
        '
        Call ApiBitBlt(invDC, 0, 0, nWidth, nHeight, maskDC, 0, 0, vbNotSrcCopy)
        '
        ' Copy background bitmap to result.
        '
        Call ApiBitBlt(resultDC, 0, 0, nWidth, nHeight, hdcDest, xDest, yDest, vbSrcCopy)
        '
        ' AND mask bitmap w/ result DC to punch hole in the background by
        ' painting black area for non-transparent portion of source bitmap.
        '
        Call ApiBitBlt(resultDC, 0, 0, nWidth, nHeight, maskDC, 0, 0, vbSrcAnd)
        '
        ' get overlapper
        '
        SetBkColor saveDC, GetBkColor(hdcSrc)
        SetTextColor saveDC, GetTextColor(hdcSrc)
        Call ApiBitBlt(saveDC, 0, 0, nWidth, nHeight, hdcSrc, xSrc, ySrc, vbSrcCopy)
        '
        ' AND with inverse monochrome mask
        '
        Call ApiBitBlt(saveDC, 0, 0, nWidth, nHeight, invDC, 0, 0, vbSrcAnd)
        '
        ' XOR these two
        '
        Call ApiBitBlt(resultDC, 0, 0, nWidth, nHeight, saveDC, 0, 0, vbSrcInvert)
        '
        ' Display transparent bitmap on background.
        '
        Call ApiBitBlt(hdcDest, xDest, yDest, nWidth, nHeight, resultDC, 0, 0, vbSrcCopy)
        '
        ' Select original objects back.
        '
        Call SelectObject(saveDC, hSavePrevBmp)
        Call SelectObject(resultDC, hDestPrevBmp)
        Call SelectObject(maskDC, hMaskPrevBmp)
        Call SelectObject(invDC, hInvPrevBmp)
        '
        ' Deallocate system resources.
        '
        Call ApiDeleteObject(hSaveBmp)
        Call ApiDeleteObject(hMaskBmp)
        Call ApiDeleteObject(hInvBmp)
        Call ApiDeleteObject(hResultBmp)
        Call DeleteDC(saveDC)
        Call DeleteDC(invDC)
        Call DeleteDC(maskDC)
        Call DeleteDC(resultDC)
        Call ReleaseDC(0, screenDC)
    End If
End Sub

Public Sub DisabledBlt( _
            Optional ByVal hdcDest As Long, _
            Optional ByVal xDest As Long, _
            Optional ByVal yDest As Long, _
            Optional ByVal nWidth As Long, _
            Optional ByVal nHeight As Long, _
            Optional ByVal xSrc As Long, _
            Optional ByVal ySrc As Long, _
            Optional ByVal clrMask As OLE_COLOR = vbWhite, _
            Optional ByVal clrHighlight As OLE_COLOR = vb3DHighlight, _
            Optional ByVal clrShadow As OLE_COLOR = vb3DShadow)
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- fix arguments
    If hdcDest = 0 Then
        hdcDest = m_ParentDC
    End If
    If nWidth = 0 Then
        nWidth = m_MemoryWidth
    End If
    If nHeight = 0 Then
        nHeight = m_MemoryHeight
    End If
    pvDisabledBlt hdcDest, xDest, yDest, nWidth, nHeight, m_MemoryDC, xSrc, ySrc, clrMask, clrHighlight, clrShadow
End Sub

Private Sub pvDisabledBlt( _
            ByVal hdcDest As Long, _
            ByVal xDest As Long, _
            ByVal yDest As Long, _
            ByVal nWidth As Long, _
            ByVal nHeight As Long, _
            ByVal hdcSrc As Long, _
            Optional ByVal xSrc As Long = 0, _
            Optional ByVal ySrc As Long = 0, _
            Optional ByVal clrMask As OLE_COLOR = vbWhite, _
            Optional ByVal clrHighlight As OLE_COLOR = vb3DHighlight, _
            Optional ByVal clrShadow As OLE_COLOR = vb3DShadow, _
            Optional ByVal hPal As Long = 0)
    Dim hdcScreen           As Long
    Dim hbmMonoSection      As Long
    Dim hbmMonoSectionSav   As Long
    Dim hdcMonoSection      As Long
    Dim hdcColor            As Long
    Dim hdcDisabled         As Long
    Dim hbmDisabledSav      As Long
    Dim lpbi                As BITMAPINFO
    Dim hbmMono             As Long
    Dim hdcMono             As Long
    Dim hbmMonoSav          As Long
    Dim lMaskColor          As Long
    Dim lMaskColorCompare   As Long
    Dim hdcMaskedSource     As Long
    Dim hbmMasked           As Long
    Dim hbmMaskedOld        As Long
    Dim hpalMaskedOld       As Long
    Dim hpalDisabledOld     As Long
    Dim hpalMonoOld         As Long
    Dim rgbBlack            As RGBQUAD
    Dim rgbWhite            As RGBQUAD
    Dim dwSys3dShadow       As Long
    Dim dwSys3dHighlight    As Long
    Dim pvBits              As Long
    Dim rgbnew(1)           As RGBQUAD
    Dim hbmDisabled         As Long
    Dim lMonoBkGrnd         As Long
    Dim lMonoBkGrndChoices(2) As Long
    Dim lIndex              As Long
    Dim hbrWhite            As Long
    Dim udtRect             As RECT
    Dim hpalHalftone        As Long
    
    hdcScreen = GetDC(0&)
    If hPal = 0 Then
        hpalHalftone = CreateHalftonePalette(hdcScreen)
        hPal = hpalHalftone
    End If
    ' Define some colors
    Call OleTranslateColor(clrShadow, hPal, dwSys3dShadow)
    Call OleTranslateColor(clrHighlight, hPal, dwSys3dHighlight)
    With rgbBlack
        .rgbBlue = 0
        .rgbGreen = 0
        .rgbRed = 0
        .rgbReserved = 0
    End With
    With rgbWhite
        .rgbBlue = 255
        .rgbGreen = 255
        .rgbRed = 255
        .rgbReserved = 255
    End With
    ' The first step is to create a monochrome bitmap with two colors:
    ' white where colors in the original are light, and black
    ' where the original is dark.  We can't simply ApiBitBlt to a bitmap.
    ' Instead, we create a monochrome (bichrome?) DIB section and ApiBitBlt
    ' to that.  Windows will do the conversion automatically based on the
    ' DIB section's palette.  (I.e. using a DIB section, Windows knows how
    ' to map "light" colors and "dark" colors to white/black, respectively.
    With lpbi.bmiHeader
        .biSize = LenB(lpbi.bmiHeader)
        .biWidth = Width
        .biHeight = -Height
        .biPlanes = 1
        .biBitCount = 1         ' monochrome
        .biCompression = BI_RGB
        .biSizeImage = 0
        .biXPelsPerMeter = 0
        .biYPelsPerMeter = 0
        .biClrUsed = 0          ' max colors used (2^1 = 2)
        .biClrImportant = 0     ' all (both :-]) colors are important
    End With
    With lpbi
        .bmiColors(0) = rgbBlack
        .bmiColors(1) = rgbWhite
    End With
    hbmMonoSection = CreateDIBSection(hdcScreen, lpbi, DIB_RGB_COLORS, pvBits, 0&, 0)
    hdcMonoSection = CreateCompatibleDC(hdcScreen)
    hbmMonoSectionSav = SelectObject(hdcMonoSection, hbmMonoSection)
    ' ApiBitBlt to the Monochrome DIB section
    ' If a mask color is provided, create a new bitmap and copy the source
    ' to it transparently.  If we don't do this, a dark mask color will be
    ' turned into the outline part of the monochrome DIB section
    ' Convert mask color and white before comparing
    ' because the Mask color might be a system color that would be evaluated
    ' to white.
    Call OleTranslateColor(vbWhite, hPal, lMaskColorCompare)
    Call OleTranslateColor(clrMask, hPal, lMaskColor)
    If lMaskColor = lMaskColorCompare Then
        Call ApiBitBlt(hdcMonoSection, 0, 0, Width, Height, hdcSrc, xSrc, ySrc, vbSrcCopy)
    Else
        hbmMasked = CreateCompatibleBitmap(hdcScreen, Width, Height)
        hdcMaskedSource = CreateCompatibleDC(hdcScreen)
        hbmMaskedOld = SelectObject(hdcMaskedSource, hbmMasked)
        hpalMaskedOld = SelectPalette(hdcMaskedSource, hPal, True)
        Call RealizePalette(hdcMaskedSource)
        ' Fill the bitmap with white
        With udtRect
            .Left = 0
            .Top = 0
            .Right = Width
            .Bottom = Height
        End With
        hbrWhite = CreateSolidBrush(vbWhite)
        Call ApiFillRect(hdcMaskedSource, udtRect, hbrWhite)
        Call ApiDeleteObject(hbrWhite)
        ' Do the transparent paint
        pvTransBlt hdcMaskedSource, 0, 0, Width, Height, hdcSrc, xSrc, ySrc, lMaskColor, hPal
        ' ApiBitBlt to the Mono DIB section.  The mask color has been turned to white.
        Call ApiBitBlt(hdcMonoSection, 0, 0, Width, Height, hdcMaskedSource, 0, 0, vbSrcCopy)
        ' Clean up
        Call SelectPalette(hdcMaskedSource, hpalMaskedOld, 1)
        Call RealizePalette(hdcMaskedSource)
        Call ApiDeleteObject(SelectObject(hdcMaskedSource, hbmMaskedOld))
        Call DeleteDC(hdcMaskedSource)
    End If
    ' Okay, we've got our B&W DIB section.
    ' Now that we have our monochrome bitmap, the final appearance that we
    ' want is this:  First, think of the black portion of the monochrome
    ' bitmap as our new version of the original bitmap.  We want to have a dark
    ' gray version of this with a light version underneath it, shifted down and
    ' to the right.  The light acts as a highlight, and it looks like the original
    ' image is a gray inset.
    '
    ' First, create a copy of the destination.  Draw the light gray transparently,
    ' and then draw the dark gray transparently
    hbmDisabled = CreateCompatibleBitmap(hdcScreen, Width, Height)
    hdcDisabled = CreateCompatibleDC(hdcScreen)
    hbmDisabledSav = SelectObject(hdcDisabled, hbmDisabled)
    hpalDisabledOld = SelectPalette(hdcDisabled, hPal, 1)
    Call RealizePalette(hdcDisabled)
    ' We used to fill the background with gray, instead copy the
    ' destination to memory DC.  This will allow a disabled image
    ' to be drawn over a background image.
    Call ApiBitBlt(hdcDisabled, 0, 0, Width, Height, hdcDest, xDest, yDest, vbSrcCopy)
    ' When painting the monochrome bitmaps transparently onto the background
    ' we need a background color that is not the light color of the dark color
    ' Provide three choices to ensure a unique color is picked.
    Call OleTranslateColor(vbBlack, hPal, lMonoBkGrndChoices(0))
    Call OleTranslateColor(vbRed, hPal, lMonoBkGrndChoices(1))
    Call OleTranslateColor(vbBlue, hPal, lMonoBkGrndChoices(2))
    ' Pick a background color choice that doesn't match
    ' the shadow or highlight color
    For lIndex = 0 To 2
        If lMonoBkGrndChoices(lIndex) <> dwSys3dHighlight And _
                lMonoBkGrndChoices(lIndex) <> dwSys3dShadow Then
            'This color can be used for a mask
            lMonoBkGrnd = lMonoBkGrndChoices(lIndex)
            Exit For
        End If
    Next
    ' Now paint a the light color shifted and transparent over the background
    ' It is not necessary to change the DIB section's color table
    ' to equal the highlight color and mask color.  In fact, setting
    ' the color table to anything besides black and white causes unpredictable
    ' results (seen in win95 with IE4, using 256 colors).
    ' Setting the Back and Text colors of the Monochrome bitmap, ensure
    ' that the desired colors are produced.
    With rgbnew(0)
        .rgbRed = (vbWhite \ 2 ^ 16) And &HFF
        .rgbGreen = (vbWhite \ 2 ^ 8) And &HFF
        .rgbBlue = vbWhite And &HFF
    End With
    With rgbnew(1)
        .rgbRed = (vbBlack \ 2 ^ 16) And &HFF
        .rgbGreen = (vbBlack \ 2 ^ 8) And &HFF
        .rgbBlue = vbBlack And &HFF
    End With
    Call SetDIBColorTable(hdcMonoSection, 0, 2, rgbnew(0))
    ' ...We can't pass a DIBSection to pvTransBlt(), so we need to
    ' make a copy of our mono DIBSection.  Notice that we only need a monochrome
    ' bitmap, but we must set its back/fore colors to the monochrome colors we
    ' want (light gray and black), and pvTransBlt() will honor them.
    hbmMono = CreateBitmap(Width, Height, 1, 1, ByVal 0&)
    hdcMono = CreateCompatibleDC(hdcScreen)
    hbmMonoSav = SelectObject(hdcMono, hbmMono)
    SetMapMode hdcMono, GetMapMode(hdcSrc)
    SetBkColor hdcMono, dwSys3dHighlight
    SetTextColor hdcMono, lMonoBkGrnd
    hpalMonoOld = SelectPalette(hdcMono, hPal, True)
    Call RealizePalette(hdcMono)
    Call ApiBitBlt(hdcMono, 0, 0, Width, Height, hdcMonoSection, 0, 0, vbSrcCopy)
    ' ...We can go ahead and call pvTransBlt with our monochrome
    ' copy
    ' Draw this transparently over the disabled bitmap
    ' ...Don't forget to shift right and left....
    Call pvTransBlt(hdcDisabled, 1, 1, Width, Height, hdcMono, 0, 0, lMonoBkGrnd, hPal)
    ' Now draw a transparent copy, using dark gray where the monochrome had
    ' black, and transparent elsewhere.  We'll use a transparent color of black.
    '
    ' ...We can't pass a DIBSection to pvTransBlt(), so we need to
    ' make a copy of our mono DIBSection.  Notice that we only need a monochrome
    ' bitmap, but we must set its back/fore colors to the monochrome colors we
    ' want (dark gray and black), and pvTransBlt() will honor them.
    ' Use hbmMono and hdcMono; already created for first color
    Call SetBkColor(hdcMono, dwSys3dShadow)
    Call SetTextColor(hdcMono, lMonoBkGrnd)
    Call ApiBitBlt(hdcMono, 0, 0, Width, Height, hdcMonoSection, 0, 0, vbSrcCopy)
    ' ...We can go ahead and call pvTransBlt with our monochrome
    ' copy
    ' Draw this transparently over the disabled bitmap
    Call pvTransBlt(hdcDisabled, 0, 0, Width, Height, hdcMono, 0, 0, lMonoBkGrnd, hPal)
    Call ApiBitBlt(hdcDest, xDest, yDest, Width, Height, hdcDisabled, 0, 0, vbSrcCopy)
    ' Okay, we're done!
    Call SelectPalette(hdcDisabled, hpalDisabledOld, 1)
    Call RealizePalette(hdcDisabled)
    Call ApiDeleteObject(SelectObject(hdcMonoSection, hbmMonoSectionSav))
    Call DeleteDC(hdcMonoSection)
    Call ApiDeleteObject(SelectObject(hdcDisabled, hbmDisabledSav))
    Call DeleteDC(hdcDisabled)
    Call ApiDeleteObject(SelectObject(hdcMono, hbmMonoSav))
    Call SelectPalette(hdcMono, hpalMonoOld, 1)
    Call RealizePalette(hdcMono)
    Call DeleteDC(hdcMono)
    Call ReleaseDC(0&, hdcScreen)
    If hpalHalftone <> 0 Then
        Call ApiDeleteObject(hpalHalftone)
    End If
End Sub

Private Sub pvTransBlt( _
            ByVal hdcDest As Long, _
            ByVal xDest As Long, _
            ByVal yDest As Long, _
            ByVal nWidth As Long, _
            ByVal nHeight As Long, _
            ByVal hdcSrc As Long, _
            Optional ByVal xSrc As Long = 0, _
            Optional ByVal ySrc As Long = 0, _
            Optional ByVal clrMask As OLE_COLOR = MASK_COLOR, _
            Optional ByVal hPal As Long = 0)
    Dim hdcMask             As Long ' hDC of the created mask image
    Dim hdcColor            As Long ' hDC of the created color image
    Dim hbmMask             As Long ' Bitmap handle to the mask image
    Dim hbmColor            As Long ' Bitmap handle to the color image
    Dim hbmColorOld         As Long
    Dim hbmMaskOld          As Long
    Dim hpalOld             As Long
    Dim hdcScreen           As Long
    Dim hdcScnBuffer        As Long ' Buffer to do all work on
    Dim hbmScnBuffer        As Long
    Dim hbmScnBufferOld     As Long
    Dim hPalBufferOld       As Long
    Dim lMaskColor          As Long
    Dim hpalHalftone        As Long

    hdcScreen = GetDC(0&)
    ' Validate palette
    If hPal = 0 Then
        hpalHalftone = CreateHalftonePalette(hdcScreen)
        hPal = hpalHalftone
    End If
    OleTranslateColor clrMask, hPal, lMaskColor
    ' Create a color bitmap to server as a copy of the destination
    ' Do all work on this bitmap and then copy it back over the destination
    ' when it's done.
    hbmScnBuffer = CreateCompatibleBitmap(hdcScreen, nWidth, nHeight)
    ' Create DC for screen buffer
    hdcScnBuffer = CreateCompatibleDC(hdcScreen)
    hbmScnBufferOld = SelectObject(hdcScnBuffer, hbmScnBuffer)
    hPalBufferOld = SelectPalette(hdcScnBuffer, hPal, True)
    RealizePalette hdcScnBuffer
    ' Copy the destination to the screen buffer
    ApiBitBlt hdcScnBuffer, 0, 0, nWidth, nHeight, hdcDest, xDest, yDest, vbSrcCopy
    ' Create a (color) bitmap for the cover (can't use CompatibleBitmap with
    ' hdcSrc, because this will create a DIB section if the original bitmap
    ' is a DIB section)
    hbmColor = CreateCompatibleBitmap(hdcScreen, nWidth, nHeight)
    ' Now create a monochrome bitmap for the mask
    hbmMask = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
    ' First, blt the source bitmap onto the cover.  We do this first
    ' and then use it instead of the source bitmap
    ' because the source bitmap may be
    ' a DIB section, which behaves differently than a bitmap.
    ' (Specifically, copying from a DIB section to a monochrome bitmap
    ' does a nearest-color selection rather than painting based on the
    ' backcolor and forecolor.
    hdcColor = CreateCompatibleDC(hdcScreen)
    hbmColorOld = SelectObject(hdcColor, hbmColor)
    hpalOld = SelectPalette(hdcColor, hPal, True)
    RealizePalette hdcColor
    ' In case hdcSrc contains a monochrome bitmap, we must set the destination
    ' foreground/background colors according to those currently set in hdcSrc
    ' (because Windows will associate these colors with the two monochrome colors)
    Call SetBkColor(hdcColor, GetBkColor(hdcSrc))
    Call SetTextColor(hdcColor, GetTextColor(hdcSrc))
    Call ApiBitBlt(hdcColor, 0, 0, nWidth, nHeight, hdcSrc, xSrc, ySrc, vbSrcCopy)
    ' Paint the mask.  What we want is white at the transparent color
    ' from the source, and black everywhere else.
    hdcMask = CreateCompatibleDC(hdcScreen)
    hbmMaskOld = SelectObject(hdcMask, hbmMask)
    ' When ApiBitBlt'ing from color to monochrome, Windows sets to 1
    ' all pixels that match the background color of the source DC.  All
    ' other bits are set to 0.
    Call SetBkColor(hdcColor, lMaskColor)
    Call SetTextColor(hdcColor, vbWhite)
    Call ApiBitBlt(hdcMask, 0, 0, nWidth, nHeight, hdcColor, 0, 0, vbSrcCopy)
    ' Paint the rest of the cover bitmap.
    '
    ' What we want here is black at the transparent color, and
    ' the original colors everywhere else.  To do this, we first
    ' paint the original onto the cover (which we already did), then we
    ' AND the inverse of the mask onto that using the DSna ternary raster
    ' operation (0x00220326 - see Win32 SDK reference, Appendix, "Raster
    ' Operation Codes", "Ternary Raster Operations", or search in MSDN
    ' for 00220326).  DSna [reverse polish] means "(not SRC) and DEST".
    '
    ' When ApiBitBlt'ing from monochrome to color, Windows transforms all white
    ' bits (1) to the background color of the destination hDC.  All black (0)
    ' bits are transformed to the foreground color.
    Call SetTextColor(hdcColor, vbBlack)
    Call SetBkColor(hdcColor, vbWhite)
    Call ApiBitBlt(hdcColor, 0, 0, nWidth, nHeight, hdcMask, 0, 0, DSna)
    ' Paint the Mask to the Screen buffer
    Call ApiBitBlt(hdcScnBuffer, 0, 0, nWidth, nHeight, hdcMask, 0, 0, vbSrcAnd)
    ' Paint the Color to the Screen buffer
    Call ApiBitBlt(hdcScnBuffer, 0, 0, nWidth, nHeight, hdcColor, 0, 0, vbSrcPaint)
    ' Copy the screen buffer to the screen
    Call ApiBitBlt(hdcDest, xDest, yDest, nWidth, nHeight, hdcScnBuffer, 0, 0, vbSrcCopy)
    ' All done!
    Call ApiDeleteObject(SelectObject(hdcColor, hbmColorOld))
    Call SelectPalette(hdcColor, hpalOld, True)
    Call RealizePalette(hdcColor)
    Call DeleteDC(hdcColor)
    Call ApiDeleteObject(SelectObject(hdcScnBuffer, hbmScnBufferOld))
    Call SelectPalette(hdcScnBuffer, hPalBufferOld, 0)
    Call RealizePalette(hdcScnBuffer)
    Call DeleteDC(hdcScnBuffer)
    Call ApiDeleteObject(SelectObject(hdcMask, hbmMaskOld))
    Call DeleteDC(hdcMask)
    Call ReleaseDC(0&, hdcScreen)
    If hpalHalftone <> 0 Then
        Call ApiDeleteObject(hpalHalftone)
    End If
End Sub

Public Sub DrawText( _
            ByVal Text As String, _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            Optional ByVal dtFlags As UcsDrawTextStyles)
    Dim wTextParams     As DRAWTEXTPARAMS
    Dim rc              As RECT

    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    With rc
        .Left = LeftX
        .Top = TopY
        .Right = RightX
        .Bottom = BottomY
    End With
    wTextParams.cbSize = Len(wTextParams)
    ApiDrawTextEx m_MemoryDC, Text, Len(Text), rc, dtFlags, wTextParams
End Sub

Public Sub ExtTextOut( _
            ByVal Text As String, _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            Optional ByVal xOffset As Long, _
            Optional ByVal yOffset As Long, _
            Optional ByVal etoFlags As UcsExtTextOutStyles)
    Dim rc As RECT
    
    On Error Resume Next
    With rc
        .Left = LeftX
        .Top = TopY
        .Right = RightX
        .Bottom = BottomY
    End With
    ApiExtTextOut m_MemoryDC, xOffset, yOffset, etoFlags, rc, Text, Len(Text), 0
End Sub

Public Sub PaintPicture( _
            ByVal oPic As StdPicture, _
            Optional ByVal xDest As Long, _
            Optional ByVal yDest As Long, _
            Optional ByVal nWidth As Long, _
            Optional ByVal nHeight As Long, _
            Optional ByVal xSrc As Long, _
            Optional ByVal ySrc As Long, _
            Optional ByVal dwRop As RasterOpConstants = vbSrcCopy, _
            Optional ByVal clrMask As OLE_COLOR = -1)
    Dim rc              As RECT
    Dim hdcPaint        As Long
    Dim hbmOrig         As Long
    Dim hEmf            As Long
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Init pvHM2Pix(oPic.Width), pvHM2Pix(oPic.Height)
    End If
    '--- fix arguments
    If nWidth = 0 Then
        nWidth = pvHM2Pix(oPic.Width)
    End If
    If nHeight = 0 Then
        nHeight = pvHM2Pix(oPic.Height)
    End If
    clrMask = TranslateColor(clrMask)
    '--- draw
    Select Case oPic.Type
    Case vbPicTypeIcon
        DrawIconEx m_MemoryDC, xDest, yDest, oPic.handle, nWidth, nHeight, 0, 0, DI_NORMAL
    Case vbPicTypeBitmap
        hdcPaint = CreateCompatibleDC(m_MemoryDC)
        hbmOrig = SelectObject(hdcPaint, oPic.handle)
        If clrMask = -1 Then
            Call ApiBitBlt(m_MemoryDC, xDest, yDest, nWidth, nHeight, hdcPaint, xSrc, ySrc, dwRop)
        Else
            pvTransBlt m_MemoryDC, xDest, yDest, nWidth, nHeight, hdcPaint, xSrc, ySrc, clrMask
        End If
        Call SelectObject(hdcPaint, hbmOrig)
        Call DeleteDC(hdcPaint)
    Case vbPicTypeEMetafile, vbPicTypeMetafile
        rc.Left = xDest
        rc.Top = yDest
        rc.Right = xDest + nWidth
        rc.Bottom = yDest + nHeight
        If oPic.Type = vbPicTypeMetafile Then
            hdcPaint = CreateEnhMetaFileLong(m_MemoryDC, vbNullString, 0, vbNullString)
            Call PlayMetaFile(hdcPaint, oPic.handle)
            hEmf = CloseEnhMetaFile(hdcPaint)
        Else
            hEmf = oPic.handle
        End If
        Call PlayEnhMetaFile(m_MemoryDC, hEmf, rc)
        If oPic.Type = vbPicTypeMetafile Then
            Call DeleteEnhMetaFile(hEmf)
        End If
    End Select
End Sub

Public Sub PaintDisabledPicture( _
            ByVal oPic As StdPicture, _
            Optional ByVal xDest As Long, _
            Optional ByVal yDest As Long, _
            Optional ByVal nWidth As Long, _
            Optional ByVal nHeight As Long, _
            Optional ByVal xSrc As Long, _
            Optional ByVal ySrc As Long, _
            Optional ByVal clrMask As OLE_COLOR = vbWhite, _
            Optional ByVal clrHighlight As OLE_COLOR = vb3DHighlight, _
            Optional ByVal clrShadow As OLE_COLOR = vb3DShadow)
    Dim oMemDC          As cMemDC
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Init pvHM2Pix(oPic.Width), pvHM2Pix(oPic.Height)
    End If
    '--- fix arguments
    If nWidth = 0 Then
        nWidth = pvHM2Pix(oPic.Width)
    End If
    If nHeight = 0 Then
        nHeight = pvHM2Pix(oPic.Height)
    End If
    '--- paint to temp dc
    Set oMemDC = New cMemDC
    With oMemDC
        .Init nWidth, nHeight
        .Cls clrMask
        .PaintPicture oPic, 0, 0, nWidth, nHeight, xSrc, ySrc
    End With
    pvDisabledBlt m_MemoryDC, xDest, yDest, nWidth, nHeight, oMemDC.hDC, 0, 0, clrMask, clrHighlight, clrShadow
End Sub

Public Function ExtractIcon(ByVal clrMask As OLE_COLOR) As StdPicture
    Dim ii              As ICONINFO
    Dim hMaskDC         As Long
    Dim hImgDC          As Long
    Dim hImgBmp         As Long
    Dim hMaskBmp        As Long
    Dim hPrevMaskBmp    As Long
    Dim hPrevImgBmp     As Long
    Dim hIcon           As Long
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Function
    End If
    '--- alloc resources
    hMaskDC = CreateCompatibleDC(0)
    hImgDC = CreateCompatibleDC(m_MemoryDC)
    hMaskBmp = CreateCompatibleBitmap(hMaskDC, Width, Height)
    hImgBmp = CreateCompatibleBitmap(m_MemoryDC, Width, Height)
    '--- select bitmaps
    hPrevMaskBmp = SelectObject(hMaskDC, hMaskBmp)
    hPrevImgBmp = SelectObject(hImgDC, hImgBmp)
    '--- copy image
    ApiBitBlt hImgDC, 0, 0, Width, Height, m_MemoryDC, 0, 0, vbSrcCopy
    '--- create mask
    SetBkColor hImgDC, clrMask
    SetTextColor hImgDC, vbWhite
    ApiBitBlt hMaskDC, 0, 0, Width, Height, hImgDC, 0, 0, vbSrcCopy
    '--- do mask image
    SetBkColor hImgDC, vbBlack
    ApiBitBlt hImgDC, 0, 0, Width, Height, hMaskDC, 0, 0, vbSrcAnd
    '--- deselect bitmaps
    Call SelectObject(hMaskDC, hPrevMaskBmp)
    Call SelectObject(hImgDC, hPrevImgBmp)
    '--- create icon
    With ii
        .fIcon = 1
        .hbmColor = hImgBmp
        .hbmMask = hMaskBmp
    End With
    hIcon = CreateIconIndirect(ii)
    '--- cleanup
    Call ApiDeleteObject(hMaskBmp)
    Call ApiDeleteObject(hImgBmp)
    Call DeleteDC(hMaskDC)
    Call DeleteDC(hImgDC)
    '--- return StdPicture
    Set ExtractIcon = pvIconToPicture(hIcon)
End Function

Private Function pvBitmapToPicture( _
            ByVal hBmp As Long, _
            Optional ByVal hPal As Long = 0) As IPicture
'--- Returns a VB picture object containing the specified bitmap.
    Dim oNewPic         As Picture
    Dim lpPictDesc      As PICTDESC
    Dim aGuid(0 To 3)   As Long
    
    '--- fill struct
    With lpPictDesc
        .Size = Len(lpPictDesc)
        .Type = vbPicTypeBitmap
        .hBmpOrIcon = hBmp
        .hPal = hPal
    End With
    '--- Fill in magic IPicture GUID {7BF80980-BF32-101A-8BBB-00AA00300CAB}
    aGuid(0) = &H7BF80980
    aGuid(1) = &H101ABF32
    aGuid(2) = &HAA00BB8B
    aGuid(3) = &HAB0C3000
    '--- Create picture from bitmap handle
    OleCreatePictureIndirect lpPictDesc, aGuid(0), True, oNewPic
    '--- success
    Set pvBitmapToPicture = oNewPic
End Function

Private Function pvIconToPicture(ByVal hIcon As Long) As IPicture
'--- Returns a VB picture object containing the specified icon.
    Dim oNewPic         As Picture
    Dim lpPictDesc      As PICTDESC
    Dim aGuid(0 To 3)   As Long
    
    On Error Resume Next
    '--- check argument
    If hIcon = 0 Then
        Exit Function
    End If
    '--- fill struct
    With lpPictDesc
        .Size = Len(lpPictDesc)
        .Type = vbPicTypeIcon
        .hBmpOrIcon = hIcon
    End With
    '--- fill in magic IPicture GUID {7BF80980-BF32-101A-8BBB-00AA00300CAB}
    aGuid(0) = &H7BF80980
    aGuid(1) = &H101ABF32
    aGuid(2) = &HAA00BB8B
    aGuid(3) = &HAB0C3000
    '--- do convert
    OleCreatePictureIndirect lpPictDesc, aGuid(0), True, oNewPic
    '--- success
    Set pvIconToPicture = oNewPic
End Function

Public Function TranslateColor(ByVal clrColor As OLE_COLOR) As Long
    '--- handle invalid (none) color
    If clrColor = -1 Then
        TranslateColor = -1
    Else
        Call OleTranslateColor(clrColor, m_MemoryPal, TranslateColor)
    End If
End Function

Private Function pvHM2Pix(ByVal Value As Double) As Double
   pvHM2Pix = Value * 1440 / 2540 / Screen.TwipsPerPixelX
End Function

'Public Sub SetFontAttributes(Optional Bold As Boolean = False, Optional Italic As Boolean = False, Optional Strikethru As Boolean = False, Optional Underline As Boolean = False)
'    With Font
'        .Bold = Bold
'        .Italic = Italic
'        .Strikethrough = Strikethru
'        .Underline = Underline
'    End With
'End Sub

Public Function TextWidth(ByVal sText As String) As Long
    Dim sz              As SIZEAPI
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Function
    End If
    GetTextExtentPoint m_MemoryDC, sText, Len(sText), sz
    '--- success
    TextWidth = sz.cx
End Function

Public Function TextHeight(ByVal sText As String) As Long
    Dim sz              As SIZEAPI
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Function
    End If
    GetTextExtentPoint m_MemoryDC, sText, Len(sText), sz
    '--- success
    TextHeight = sz.cy
End Function

Public Sub NormalizeRect( _
            LeftX As Long, _
            TopY As Long, _
            RightX As Long, _
            BottomY As Long)
    Dim lTmp        As Long
        
    If BottomY < TopY Then
        lTmp = BottomY
        BottomY = TopY
        TopY = lTmp
    End If
    If RightX < LeftX Then
        lTmp = RightX
        RightX = LeftX
        LeftX = lTmp
    End If
End Sub

Public Sub SetClipRect( _
            ByVal LeftX As Long, _
            Optional ByVal TopY As Long, _
            Optional ByVal RightX As Long, _
            Optional ByVal BottomY As Long)
    Dim hrgn        As Long
    
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    If LeftX >= 0 Then
        NormalizeRect LeftX, TopY, RightX, BottomY
        hrgn = CreateRectRgn(LeftX, TopY, RightX, BottomY)
    End If
    SelectClipRgn m_MemoryDC, hrgn
    If hrgn <> 0 Then
        ApiDeleteObject hrgn
    End If
End Sub

Public Sub SetDIBits( _
            ByVal xDest As Long, _
            ByVal yDest As Long, _
            ByVal nWidth As Long, _
            ByVal nHeight As Long, _
            aBits() As Byte, _
            Optional ByVal dwRop As RasterOpConstants = vbSrcCopy)
    Dim bmi                 As BITMAPINFO
    
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    With bmi.bmiHeader
        .biSize = Len(bmi.bmiHeader)
        .biWidth = nWidth
        .biHeight = nHeight
        .biPlanes = 1
        .biBitCount = 24
        .biCompression = BI_RGB
    End With
    StretchDIBits m_MemoryDC, xDest, yDest, nWidth, nHeight, 0, 0, nWidth, nHeight, aBits(0), bmi, DIB_RGB_COLORS, dwRop
End Sub

Public Sub DrawEllipse( _
            Optional ByVal LeftX As Long, _
            Optional ByVal TopY As Long, _
            Optional ByVal RightX As Long = -1, _
            Optional ByVal BottomY As Long = -1, _
            Optional ByVal clrEllipse As Long = -1, _
            Optional ByVal hpnEllipse As Long)
'    Dim lb              As LOGBRUSH
'    Dim hbrOrig         As Long
    
    On Error Resume Next
    '--- state check
    If Not IsCreated() Then
        Exit Sub
    End If
    '--- create pen if neccessary
    If clrEllipse <> -1 Then
        hpnEllipse = CreatePen(PS_SOLID, 1, TranslateColor(clrEllipse))
    End If
    Pen = hpnEllipse
    '--- draw ellipse
    ApiArc hDC, LeftX, _
                TopY, _
                IIf(RightX < LeftX, Width, RightX), _
                IIf(BottomY < TopY, Height, BottomY), _
                LeftX, TopY, LeftX, TopY
'    lb.lbStyle = BS_HOLLOW
'    hbrOrig = SelectObject(m_MemoryDC, CreateBrushIndirect(lb))
'    ApiEllipse m_MemoryDC, LeftX, _
                TopY, _
                IIf(RightX < LeftX, Width, RightX), _
                IIf(BottomY < TopY, Height, BottomY)
'    Call ApiDeleteObject(SelectObject(m_MemoryDC, hbrOrig))
End Sub

Public Sub SetPixel( _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            Optional clrColor As Long = vbWhite)
    ApiSetPixel m_MemoryDC, LeftX, TopY, TranslateColor(clrColor)
End Sub

Public Function GetPixel( _
            ByVal LeftX As Long, _
            ByVal TopY As Long) As Long
    GetPixel = ApiGetPixel(m_MemoryDC, LeftX, TopY)
End Function

'=========================================================================
' Class events
'=========================================================================

Private Sub Class_Initialize()
    m_MemoryDC = 0
End Sub

Private Sub Class_Terminate()
    Dim lErrNumber      As Long
    Dim sErrSrc         As String
    Dim sErrDesc        As String
    
    '--- preserve errorinfo as to try not to clear the err object
    '---   in Destroy -- it's using On Error Resume Next. usually
    '---   this kind of support is done with Push/PopError funcs
    lErrNumber = Err.Number
    sErrSrc = Err.Source
    sErrDesc = Err.Description
    
    Destroy '--- installs On Error Resume Next
    
    Err.Number = lErrNumber
    Err.Source = sErrSrc
    Err.Description = sErrDesc
End Sub


