VERSION 5.00
Begin VB.UserControl ctxOutlookBar 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   3576
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1512
   OLEDropMode     =   1  'Manual
   PropertyPages   =   "ctxOutlookBar.ctx":0000
   ScaleHeight     =   3576
   ScaleWidth      =   1512
   ToolboxBitmap   =   "ctxOutlookBar.ctx":003C
End
Attribute VB_Name = "ctxOutlookBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'=========================================================================
'
'   You are free to use this source as long as this copyright message
'     appears on your program's "About" dialog:
'
'   Outlook Bar Project
'   Copyright (c) 2002 Vlad Vissoultchev (wqw@geocities.com)
'
'=========================================================================
Option Explicit
Private Const MODULE_NAME As String = "ctxOutlookBar"

'=========================================================================
' Public Events
'=========================================================================

Event ButtonClick(ByVal oBtn As cButton)
Attribute ButtonClick.VB_MemberFlags = "200"
Event ButtonDblClick(ByVal oBtn As cButton)
Event Click()
Event DblClick()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event OLECompleteDrag(Effect As Long)
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Event OLESetData(Data As DataObject, DataFormat As Integer)
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Event KeyDown(KeyCode As Integer, Shift As Integer)
Event KeyPress(KeyAscii As Integer)
Event KeyUp(KeyCode As Integer, Shift As Integer)
Event SelItemChange()
Event SelGroupChange()

'=========================================================================
' Public Enums
'=========================================================================

Public Enum UcsOleDragModeEnum
    ucsOleDragManual = 0
    ucsOleDragAutomatic = 1
End Enum

Public Enum UcsOleDropModeEnum
    ucsOleDropNone = 0
    ucsOleDropManual = 1
End Enum

Public Enum UcsHitTestEnum
    ucsHitGroupButton
    ucsHitItemButton
    ucsHitScrollupArrow
    ucsHitScrolldownArrow
End Enum

'=========================================================================
' API
'=========================================================================

'--- for mouse_event
Private Const MOUSEEVENTF_LEFTDOWN      As Long = &H2
'--- for DrawFrameControl
Private Const DFCS_FLAT                 As Long = &H4000
Private Const DFCS_PUSHED               As Long = &H200
Private Const DFCS_SCROLLDOWN           As Long = &H1
Private Const DFCS_SCROLLUP             As Long = &H0
Private Const DFC_SCROLL                As Long = &H3
'--- for InitCommonControlsEx
Private Const ICC_TAB_CLASSES           As Long = &H8
'--- for CreateWindowEx (tooltip window)
Private Const TOOLTIPS_CLASS            As String = "tooltips_class32"
Private Const WS_POPUP                  As Long = &H80000000
Private Const WS_EX_TOPMOST             As Long = &H8
Private Const TTS_ALWAYSTIP             As Long = &H1
Private Const TTS_NOPREFIX              As Long = &H2
'--- for tooltip window messages
Private Const TTM_ADDTOOL               As Long = (&H400 + 4)
Private Const TTM_DELTOOL               As Long = (&H400 + 5)
Private Const TTM_NEWTOOLRECT           As Long = (&H400 + 6)
Private Const TTM_UPDATETIPTEXT         As Long = (&H400 + 12)
Private Const TTM_SETMAXTIPWIDTH        As Long = (&H400 + 24)
'--- for TOOLINFO.uFlags
Private Const TTF_SUBCLASS              As Long = &H10

Private Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cButtons As Long, ByVal dwExtraInfo As Long)
Private Declare Function UpdateWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function DrawFrameControl Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function ApiInitCommonControlsEx Lib "comctl32" Alias "InitCommonControlsEx" (ICCE As INITCOMMONCONTROLSEX) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hwndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Private Type TOOLINFO
    cbSize      As Long
    uFlags      As Long
    hwnd        As Long
    uId         As Long
    RECT        As RECT
    hinst       As Long
    lpszText    As Long
End Type

Private Type INITCOMMONCONTROLSEX
   dwSize       As Long
   dwICC        As Long
End Type

'=========================================================================
' Constants and member variables
'=========================================================================

Private Const CAP_MSG               As String = "ButtonBar Control"
Private Const DEF_MASKCOLOR         As Long = &HFF00FF
Private Const DEF_ANIMSTEPS         As Long = 5
Private Const DEF_OLEDRAGMODE       As Long = ucsOleDragManual
Private Const DEF_OLEDROPMODE       As Long = ucsOleDropManual
Private Const DEF_SCROLLITEMSCOUNT  As Long = 2
Private Const INNER_BORDER          As Long = 4
Private Const STR_CONTROL           As String = "Control"
Private Const STR_GROUP             As String = "Group"
Private Const STR_ITEM              As String = "Item"
Private Const STR_ITEM_LARGE_ICONS  As String = "Item (in Large Icons)"
Private Const STR_SMALL_ICON        As String = "Small Icon"
Private Const STR_LARGE_ICON        As String = "Large Icon"
Private Const STR_HOVER             As String = "Hover"
Private Const STR_PRESSED           As String = "Pressed"
Private Const STR_SELECTED          As String = "Selected"
Private Const SCROLL_ARROW_SIZE     As Long = 16
Private Const ITEM_VERT_DISTANCE    As Long = 0

Private WithEvents m_oFmtContrl As cFormatDef
Attribute m_oFmtContrl.VB_VarHelpID = -1
Private WithEvents m_oFmtGrpNrm As cFormatDef
Attribute m_oFmtGrpNrm.VB_VarHelpID = -1
Private WithEvents m_oFmtGrpHvr As cFormatDef
Attribute m_oFmtGrpHvr.VB_VarHelpID = -1
Private WithEvents m_oFmtGrpPrs As cFormatDef
Attribute m_oFmtGrpPrs.VB_VarHelpID = -1
Private WithEvents m_oFmtGrpSel As cFormatDef
Attribute m_oFmtGrpSel.VB_VarHelpID = -1
Private WithEvents m_oFmtItmNrm As cFormatDef
Attribute m_oFmtItmNrm.VB_VarHelpID = -1
Private WithEvents m_oFmtItmLrg As cFormatDef
Attribute m_oFmtItmLrg.VB_VarHelpID = -1
Private WithEvents m_oFmtItmHvr As cFormatDef
Attribute m_oFmtItmHvr.VB_VarHelpID = -1
Private WithEvents m_oFmtItmPrs As cFormatDef
Attribute m_oFmtItmPrs.VB_VarHelpID = -1
Private WithEvents m_oFmtItmSel As cFormatDef
Attribute m_oFmtItmSel.VB_VarHelpID = -1
Private WithEvents m_oFmtSIcNrm As cFormatDef
Attribute m_oFmtSIcNrm.VB_VarHelpID = -1
Private WithEvents m_oFmtSIcHvr As cFormatDef
Attribute m_oFmtSIcHvr.VB_VarHelpID = -1
Private WithEvents m_oFmtSIcPrs As cFormatDef
Attribute m_oFmtSIcPrs.VB_VarHelpID = -1
Private WithEvents m_oFmtSIcSel As cFormatDef
Attribute m_oFmtSIcSel.VB_VarHelpID = -1
Private WithEvents m_oFmtLIcNrm As cFormatDef
Attribute m_oFmtLIcNrm.VB_VarHelpID = -1
Private WithEvents m_oFmtLIcHvr As cFormatDef
Attribute m_oFmtLIcHvr.VB_VarHelpID = -1
Private WithEvents m_oFmtLIcPrs As cFormatDef
Attribute m_oFmtLIcPrs.VB_VarHelpID = -1
Private WithEvents m_oFmtLIcSel As cFormatDef
Attribute m_oFmtLIcSel.VB_VarHelpID = -1
Private m_oRendContrl           As cFormatDef
Attribute m_oRendContrl.VB_VarHelpID = -1
Private m_oRendGrpNrm           As cFormatDef
Attribute m_oRendGrpNrm.VB_VarHelpID = -1
Private m_oRendGrpHvr           As cFormatDef
Attribute m_oRendGrpHvr.VB_VarHelpID = -1
Private m_oRendGrpPrs           As cFormatDef
Attribute m_oRendGrpPrs.VB_VarHelpID = -1
Private m_oRendGrpSel           As cFormatDef
Attribute m_oRendGrpSel.VB_VarHelpID = -1
Private m_oRendItmNrm           As cFormatDef
Attribute m_oRendItmNrm.VB_VarHelpID = -1
Private m_oRendItmNrmLrg        As cFormatDef
Private m_oRendItmHvr           As cFormatDef
Attribute m_oRendItmHvr.VB_VarHelpID = -1
Private m_oRendItmHvrLrg        As cFormatDef
Private m_oRendItmPrs           As cFormatDef
Attribute m_oRendItmPrs.VB_VarHelpID = -1
Private m_oRendItmPrsLrg        As cFormatDef
Private m_oRendItmSel           As cFormatDef
Attribute m_oRendItmSel.VB_VarHelpID = -1
Private m_oRendItmSelLrg        As cFormatDef
Private m_oRendSIcNrm           As cFormatDef
Attribute m_oRendSIcNrm.VB_VarHelpID = -1
Private m_oRendSIcHvr           As cFormatDef
Attribute m_oRendSIcHvr.VB_VarHelpID = -1
Private m_oRendSIcPrs           As cFormatDef
Attribute m_oRendSIcPrs.VB_VarHelpID = -1
Private m_oRendSIcSel           As cFormatDef
Attribute m_oRendSIcSel.VB_VarHelpID = -1
Private m_oRendLIcNrm           As cFormatDef
Private m_oRendLIcHvr           As cFormatDef
Private m_oRendLIcPrs           As cFormatDef
Private m_oRendLIcSel           As cFormatDef
Private WithEvents m_oTop       As cButton
Attribute m_oTop.VB_VarHelpID = -1
Private WithEvents m_oFont      As StdFont
Attribute m_oFont.VB_VarHelpID = -1
Private m_clrMask               As OLE_COLOR
Private m_oSelectedItem         As cButton
Private m_oSelectedGroup        As cButton
Private m_oOver                 As cButton
Private m_oPressed              As cButton
Private m_lItemHeight           As Long
Private m_lGroupHeight          As Long
Private m_lAnimationSteps       As Long
Private m_eOleDragMode          As UcsOleDragModeEnum
Private m_lGroupOffset          As Long
Private m_lScrollItemsCount     As Long
Private m_hWndTooltip           As Long
Private m_lScrollBtnState       As Long
#If DebugMode Then
    Private m_sDebugID          As String
#End If

'=========================================================================
' Error handling
'=========================================================================

Private Sub RaiseError(sFunc As String)
    PushError sFunc, MODULE_NAME
    PopRaiseError
End Sub

Private Function ShowError(sFunc As String) As VbMsgBoxResult
    PushError sFunc, MODULE_NAME
    ShowError = PopShowError(CAP_MSG)
End Function

'=========================================================================
' Properties
'=========================================================================

'= design-time ===========================================================

Property Get Font() As StdFont
    Set Font = m_oFont
End Property

Property Set Font(ByVal oValue As StdFont)
    CopyFont m_oFont, oValue
End Property

Property Get FormatControl() As cFormatDef
    Set FormatControl = m_oFmtContrl
    Set FormatControl.ParentFont = Font
End Property

Property Set FormatControl(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_CONTROL_FORMAT
    End If
    m_oFmtContrl.Contents = oValue.Contents
End Property

Property Get FormatGroup() As cFormatDef
    Set FormatGroup = m_oFmtGrpNrm
End Property

Property Set FormatGroup(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_GROUP_FORMAT
    End If
    m_oFmtGrpNrm.Contents = oValue.Contents
End Property

Property Get FormatGroupHover() As cFormatDef
    Set FormatGroupHover = m_oFmtGrpHvr
End Property

Property Set FormatGroupHover(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_GROUP_FORMAT_HOVER
    End If
    m_oFmtGrpHvr.Contents = oValue.Contents
End Property

Property Get FormatGroupPressed() As cFormatDef
    Set FormatGroupPressed = m_oFmtGrpPrs
End Property

Property Set FormatGroupPressed(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_GROUP_FORMAT_PRESSED
    End If
    m_oFmtGrpPrs.Contents = oValue.Contents
End Property

Property Get FormatGroupSelected() As cFormatDef
    Set FormatGroupSelected = m_oFmtGrpSel
End Property

Property Set FormatGroupSelected(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_GROUP_FORMAT_SELECTED
    End If
    m_oFmtGrpSel.Contents = oValue.Contents
End Property

Property Get FormatItem() As cFormatDef
    Set FormatItem = m_oFmtItmNrm
End Property

Property Set FormatItem(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_ITEM_FORMAT
    End If
    m_oFmtItmNrm.Contents = oValue.Contents
End Property

Property Get FormatItemLargeIcons() As cFormatDef
    Set FormatItemLargeIcons = m_oFmtItmLrg
End Property

Property Set FormatItemLargeIcons(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_ITEM_FORMAT_LARGE_ICONS
    End If
    m_oFmtItmLrg.Contents = oValue.Contents
End Property


Property Get FormatItemHover() As cFormatDef
    Set FormatItemHover = m_oFmtItmHvr
End Property

Property Set FormatItemHover(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_ITEM_FORMAT_HOVER
    End If
    m_oFmtItmHvr.Contents = oValue.Contents
End Property

Property Get FormatItemPressed() As cFormatDef
    Set FormatItemPressed = m_oFmtItmPrs
End Property

Property Set FormatItemPressed(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_ITEM_FORMAT_PRESSED
    End If
    m_oFmtItmPrs.Contents = oValue.Contents
End Property

Property Get FormatItemSelected() As cFormatDef
    Set FormatItemSelected = m_oFmtItmSel
End Property

Property Set FormatItemSelected(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_ITEM_FORMAT_SELECTED
    End If
    m_oFmtItmSel.Contents = oValue.Contents
End Property

Property Get FormatSmallIcon() As cFormatDef
    Set FormatSmallIcon = m_oFmtSIcNrm
End Property

Property Set FormatSmallIcon(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_SMALL_ICON_FORMAT
    End If
    m_oFmtSIcNrm.Contents = oValue.Contents
End Property

Property Get FormatSmallIconHover() As cFormatDef
    Set FormatSmallIconHover = m_oFmtSIcHvr
End Property

Property Set FormatSmallIconHover(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_SMALL_ICON_FORMAT_HOVER
    End If
    m_oFmtSIcHvr.Contents = oValue.Contents
End Property

Property Get FormatSmallIconPressed() As cFormatDef
    Set FormatSmallIconPressed = m_oFmtSIcPrs
End Property

Property Set FormatSmallIconPressed(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_SMALL_ICON_FORMAT_PRESSED
    End If
    m_oFmtSIcPrs.Contents = oValue.Contents
End Property

Property Get FormatSmallIconSelected() As cFormatDef
    Set FormatSmallIconSelected = m_oFmtSIcSel
End Property

Property Set FormatSmallIconSelected(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_SMALL_ICON_FORMAT_SELECTED
    End If
    m_oFmtSIcSel.Contents = oValue.Contents
End Property

Property Get FormatLargeIcon() As cFormatDef
    Set FormatLargeIcon = m_oFmtLIcNrm
End Property

Property Set FormatLargeIcon(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_LARGE_ICON_FORMAT
    End If
    m_oFmtLIcNrm.Contents = oValue.Contents
End Property

Property Get FormatLargeIconHover() As cFormatDef
    Set FormatLargeIconHover = m_oFmtLIcHvr
End Property

Property Set FormatLargeIconHover(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_LARGE_ICON_FORMAT_HOVER
    End If
    m_oFmtLIcHvr.Contents = oValue.Contents
End Property

Property Get FormatLargeIconPressed() As cFormatDef
    Set FormatLargeIconPressed = m_oFmtLIcPrs
End Property

Property Set FormatLargeIconPressed(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_LARGE_ICON_FORMAT_PRESSED
    End If
    m_oFmtLIcPrs.Contents = oValue.Contents
End Property

Property Get FormatLargeIconSelected() As cFormatDef
    Set FormatLargeIconSelected = m_oFmtLIcSel
End Property

Property Set FormatLargeIconSelected(ByVal oValue As cFormatDef)
    If oValue Is Nothing Then
        Set oValue = DEF_LARGE_ICON_FORMAT_SELECTED
    End If
    m_oFmtLIcSel.Contents = oValue.Contents
End Property

Property Get MaskColor() As OLE_COLOR
    MaskColor = m_clrMask
End Property

Property Let MaskColor(ByVal clrValue As OLE_COLOR)
    m_clrMask = clrValue
    pvPropertyChanged
End Property

Property Get AnimationSteps() As Long
    AnimationSteps = m_lAnimationSteps
End Property

Property Let AnimationSteps(ByVal lValue As Long)
    m_lAnimationSteps = IIf(lValue < 1 Or lValue > 100, DEF_ANIMSTEPS, lValue)
    pvPropertyChanged
End Property

Property Get OleDragMode() As UcsOleDragModeEnum
    OleDragMode = m_eOleDragMode
End Property

Property Let OleDragMode(ByVal eValue As UcsOleDragModeEnum)
    m_eOleDragMode = eValue
    PropertyChanged
End Property

Property Get OleDropMode() As UcsOleDropModeEnum
    OleDropMode = UserControl.OleDropMode
End Property

Property Let OleDropMode(ByVal eValue As UcsOleDropModeEnum)
    UserControl.OleDropMode = eValue
    PropertyChanged
End Property

Property Get ScrollItemsCount() As Long
    ScrollItemsCount = m_lScrollItemsCount
End Property

Property Let ScrollItemsCount(ByVal lValue As Long)
    m_lScrollItemsCount = IIf(lValue < 1 Or lValue > 100, DEF_SCROLLITEMSCOUNT, lValue)
    PropertyChanged
End Property

'= run-time ==============================================================

Property Get Groups() As cButtons
    Set Groups = m_oTop.GroupItems
End Property

Property Set Groups(ByVal oValue As cButtons)
    m_oTop.GroupItems.Contents = oValue.Contents
    pvPropertyChanged
End Property

Property Get SelectedGroup() As cButton
    Set SelectedGroup = m_oSelectedGroup
End Property

Property Set SelectedGroup(ByVal oValue As cButton)
    If Not m_oSelectedGroup Is oValue Then
        Set m_oSelectedGroup = oValue
        RefreshControl
        RaiseEvent SelGroupChange
    End If
End Property

Property Get SelectedItem() As cButton
    Set SelectedItem = m_oSelectedItem
End Property

Property Set SelectedItem(ByVal oValue As cButton)
    If Not m_oSelectedItem Is oValue Then
        Set m_oSelectedItem = oValue
        RefreshControl
        RaiseEvent SelItemChange
    End If
End Property

'= private ===============================================================

Private Property Get DEF_FONT() As StdFont
    Set DEF_FONT = New StdFont
    With DEF_FONT
        .Name = "Tahoma"
        .Size = 8
    End With
End Property

Private Property Get DEF_CONTROL_FORMAT() As cFormatDef
    Static oFmt         As cFormatDef
    
    If pvInitFormat(oFmt, STR_CONTROL, , ucsFbdSingle3D, ucsGrdSolid, ucsFhaCenter, ucsFvaMiddle, , &HD1D8DB) Then
        With oFmt
            .ForeColor = vbWindowText
            .OffsetX = 0
            .OffsetY = 0
            .Padding = 2
            .BorderSunken = ucsTriFalse
            Set .ParentFont = Font
        End With
    End If
    Set DEF_CONTROL_FORMAT = oFmt
End Property

Private Property Get DEF_GROUP_FORMAT() As cFormatDef
    Static oFmt         As cFormatDef
    
    pvInitFormat oFmt, STR_GROUP, FormatControl, ucsFbdSingle3D, ucsGrdSolid, ucsFhaCenter
    Set DEF_GROUP_FORMAT = oFmt
End Property

Private Property Get DEF_GROUP_FORMAT_HOVER() As cFormatDef
    Static oFmt         As cFormatDef
        
    Call pvInitFormat(oFmt, STR_HOVER, FormatGroup, ucsFbdDouble3D)
    Set DEF_GROUP_FORMAT_HOVER = oFmt
End Property

Private Property Get DEF_GROUP_FORMAT_PRESSED() As cFormatDef
    Static oFmt         As cFormatDef

    If pvInitFormat(oFmt, STR_PRESSED, FormatGroup, ucsFbdDouble3D) Then
        With oFmt
            .BorderSunken = ucsTriTrue
        End With
    End If
    Set DEF_GROUP_FORMAT_PRESSED = oFmt
End Property

Private Property Get DEF_GROUP_FORMAT_SELECTED() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_SELECTED, FormatGroup
    Set DEF_GROUP_FORMAT_SELECTED = oFmt
End Property

Private Property Get DEF_ITEM_FORMAT() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_ITEM, FormatControl, ucsFbdNone, ucsGrdTransparent, ucsFhaLeft
    Set DEF_ITEM_FORMAT = oFmt
End Property

Private Property Get DEF_ITEM_FORMAT_LARGE_ICONS() As cFormatDef
    Static oFmt         As cFormatDef

    If pvInitFormat(oFmt, STR_ITEM_LARGE_ICONS, FormatControl, ucsFbdNone, ucsGrdTransparent, ucsFhaCenter) Then
        oFmt.Padding = 7
    End If
    Set DEF_ITEM_FORMAT_LARGE_ICONS = oFmt
End Property

Private Property Get DEF_ITEM_FORMAT_HOVER() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_HOVER, FormatItem
    Set DEF_ITEM_FORMAT_HOVER = oFmt
End Property

Private Property Get DEF_ITEM_FORMAT_PRESSED() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_PRESSED, FormatItem
    Set DEF_ITEM_FORMAT_PRESSED = oFmt
End Property

Private Property Get DEF_ITEM_FORMAT_SELECTED() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_SELECTED, FormatItem
    Set DEF_ITEM_FORMAT_SELECTED = oFmt
End Property

Private Property Get DEF_SMALL_ICON_FORMAT() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_SMALL_ICON, FormatControl, ucsFbdNone, ucsGrdTransparent, ucsFhaLeft, ucsFvaMiddle
    Set DEF_SMALL_ICON_FORMAT = oFmt
End Property

Private Property Get DEF_SMALL_ICON_FORMAT_HOVER() As cFormatDef
    Static oFmt         As cFormatDef

    Call pvInitFormat(oFmt, STR_HOVER, FormatSmallIcon, ucsFbdFixed, ucsGrdSolid, , , vbHighlight, &HD2BDB6)
    Set DEF_SMALL_ICON_FORMAT_HOVER = oFmt
End Property

Private Property Get DEF_SMALL_ICON_FORMAT_PRESSED() As cFormatDef
    Static oFmt         As cFormatDef

    Call pvInitFormat(oFmt, STR_PRESSED, FormatSmallIcon, ucsFbdFixed, ucsGrdSolid, , , vbHighlight, &HB59285)
    Set DEF_SMALL_ICON_FORMAT_PRESSED = oFmt
End Property

Private Property Get DEF_SMALL_ICON_FORMAT_SELECTED() As cFormatDef
    Static oFmt         As cFormatDef

    Call pvInitFormat(oFmt, STR_SELECTED, FormatSmallIcon, ucsFbdFixed, ucsGrdSolid, , , vbHighlight, &HD2BDB6)
    Set DEF_SMALL_ICON_FORMAT_SELECTED = oFmt
End Property

Private Property Get DEF_LARGE_ICON_FORMAT() As cFormatDef
    Static oFmt         As cFormatDef

    pvInitFormat oFmt, STR_LARGE_ICON, FormatControl, ucsFbdNone, ucsGrdTransparent, ucsFhaCenter, ucsFvaTop
    Set DEF_LARGE_ICON_FORMAT = oFmt
End Property

Private Property Get DEF_LARGE_ICON_FORMAT_HOVER() As cFormatDef
    Static oFmt         As cFormatDef

    Call pvInitFormat(oFmt, STR_HOVER, FormatLargeIcon, ucsFbdFixed, ucsGrdSolid, , , vbHighlight, &HD2BDB6)
    Set DEF_LARGE_ICON_FORMAT_HOVER = oFmt
End Property

Private Property Get DEF_LARGE_ICON_FORMAT_PRESSED() As cFormatDef
    Static oFmt         As cFormatDef

    Call pvInitFormat(oFmt, STR_PRESSED, FormatLargeIcon, ucsFbdFixed, ucsGrdSolid, , , vbHighlight, &HB59285)
    Set DEF_LARGE_ICON_FORMAT_PRESSED = oFmt
End Property

Private Property Get DEF_LARGE_ICON_FORMAT_SELECTED() As cFormatDef
    Static oFmt         As cFormatDef

    Call pvInitFormat(oFmt, STR_SELECTED, FormatLargeIcon, ucsFbdFixed, ucsGrdSolid, , , vbHighlight, &HD2BDB6)
    Set DEF_LARGE_ICON_FORMAT_SELECTED = oFmt
End Property

Private Property Let ApiTooltipText(sValue As String)
    Static ti           As TOOLINFO
    Static sText        As String
    Dim hr              As Long
    Dim bNew            As Boolean
    
    If m_hWndTooltip = 0 Then
        Exit Property
    End If
    With ti
        bNew = (.cbSize = 0)
        .cbSize = LenB(ti)
        .uFlags = TTF_SUBCLASS
        .hwnd = UserControl.hwnd
        .uId = 0
        .hinst = App.hInstance
        sText = StrConv(sValue, vbFromUnicode)
        .lpszText = StrPtr(sText)
        With .RECT
            .Right = ScaleWidth \ Screen.TwipsPerPixelX
            .Bottom = ScaleHeight \ Screen.TwipsPerPixelY
        End With
    End With
    If bNew Then
        hr = SendMessage(m_hWndTooltip, TTM_ADDTOOL, 0, ti)
    Else
        If Len(sValue) > 0 Then
            hr = SendMessage(m_hWndTooltip, TTM_UPDATETIPTEXT, 0, ti)
            hr = SendMessage(m_hWndTooltip, TTM_NEWTOOLRECT, 0, ti)
        Else
            hr = SendMessage(m_hWndTooltip, TTM_DELTOOL, 0, ti)
            ti.cbSize = 0
        End If
    End If
End Property

'=========================================================================
' Methods
'=========================================================================

Public Sub RefreshControl()
    Dim rc              As RECT
    
    On Error Resume Next
    pvFixGroupOffset
    AutoRedraw = False
    GetClientRect hwnd, rc
    InvalidateRect hwnd, rc, 1
End Sub

Public Function HitTest(ByVal X As Long, ByVal Y As Long, oBtn As cButton) As UcsHitTestEnum
    Const FUNC_NAME     As String = "HitTest"
    Dim lIdx            As Long
    Dim lTop            As Long
    Dim lBottom         As Long
    Dim lGroupHeight    As Long
    Dim lItemHeight     As Long
    Dim lWidth          As Long
    Dim oGroup          As cButtons
    
    On Error GoTo EH
    X = X \ Screen.TwipsPerPixelX
    Y = Y \ Screen.TwipsPerPixelY
    lWidth = ScaleWidth \ Screen.TwipsPerPixelX
    lGroupHeight = m_lGroupHeight
    lTop = 0
    lBottom = ScaleHeight \ Screen.TwipsPerPixelY
    For lIdx = 1 To Groups.Count
        If X >= 1 And Y >= lTop And X <= lWidth - 1 And Y <= lTop + lGroupHeight Then
            Set oBtn = Groups(lIdx)
            HitTest = ucsHitGroupButton
            Exit Function
        End If
        lTop = lTop + lGroupHeight + 1
        If Groups(lIdx).Selected Then
            Exit For
        End If
    Next
    For lIdx = Groups.Count To lIdx Step -1
        If Groups(lIdx).Selected Then
            Exit For
        End If
        lBottom = lBottom - lGroupHeight - 1
        If X >= 1 And Y >= lBottom And X < lWidth - 1 And Y <= lBottom + lGroupHeight Then
            Set oBtn = Groups(lIdx)
            HitTest = ucsHitGroupButton
            Exit Function
        End If
    Next
    If lBottom > lTop Then
        If lIdx >= 1 And lIdx <= Groups.Count Then
            lTop = lTop + INNER_BORDER
            lBottom = lBottom - INNER_BORDER
            If X >= INNER_BORDER And X <= lWidth - INNER_BORDER And _
                    Y >= lTop And Y <= lBottom Then
                pvGetItemInfo Groups(lIdx), lItemHeight, 0, 0
                Set oGroup = Groups(lIdx).GroupItems
                '--- if scroll arrows are potentailly visible and near the right edge
                If lTop + (lItemHeight + ITEM_VERT_DISTANCE) * oGroup.Count > lBottom _
                        And X >= lWidth - INNER_BORDER - SCROLL_ARROW_SIZE Then
                    '--- if upper scroll arrow visible and over it
                    If m_lGroupOffset > 0 And _
                            Y < lTop + SCROLL_ARROW_SIZE Then
                        Set oBtn = Nothing
                        HitTest = ucsHitScrollupArrow
                        Exit Function
                    End If
                    '--- if lower scroll arrow visible and over it
                    If oGroup.Count * (lItemHeight + ITEM_VERT_DISTANCE) - m_lGroupOffset >= lBottom - lTop And _
                            Y >= lBottom - SCROLL_ARROW_SIZE Then
                        Set oBtn = Nothing
                        HitTest = ucsHitScrolldownArrow
                        Exit Function
                    End If
                End If
                '--- check if on an item
                For lIdx = 1 To oGroup.Count
                    If Y + m_lGroupOffset >= lTop And Y + m_lGroupOffset < lTop + lItemHeight Then
                        Set oBtn = oGroup(lIdx)
                        HitTest = ucsHitItemButton
                        Exit Function
                    End If
                    lTop = lTop + lItemHeight + ITEM_VERT_DISTANCE
                Next
            End If
        End If
    End If
    Exit Function
EH:
    RaiseError FUNC_NAME
End Function

Public Sub OleDrag()
    UserControl.OleDrag
End Sub

Public Sub EnsureVisible( _
            ByVal oBtn As cButton, _
            ByVal bAnimate As Boolean)
    Const FUNC_NAME     As String = "EnsureVisible"
    Dim lItemHeight     As Long
    Dim lGroupVisibleHeight As Long
    Dim lOffset         As Long
    
    On Error GoTo EH
    '--- argument check
    If oBtn Is Nothing Then
        Exit Sub
    End If
    If oBtn.Class <> ucsBtnClassItem Then
        Exit Sub
    End If
    If oBtn.Parent Is Nothing Then
        Exit Sub
    End If
    '--- make sure button is a control item
    Set oBtn = Groups(oBtn.Parent.Index).GroupItems(oBtn.Index)
    If Not SelectedGroup Is oBtn.Parent Then
        Set SelectedGroup = oBtn.Parent
    End If
    '--- get more info for button's group
    pvGetItemInfo oBtn.Parent, lItemHeight, 0, 0
    lGroupVisibleHeight = ScaleHeight \ Screen.TwipsPerPixelY - Groups.Count * (m_lGroupHeight + 1) - 2 * (INNER_BORDER + m_oRendContrl.BorderSize) + 1
    '--- ensure enough offset
    lOffset = pvMax(oBtn.Index * lItemHeight - lGroupVisibleHeight, 0)
    If m_lGroupOffset < lOffset Then
        If bAnimate Then
            pvAnimateGroup lOffset
        Else
            m_lGroupOffset = lOffset
        End If
    End If
    lOffset = (oBtn.Index - 1) * (lItemHeight + ITEM_VERT_DISTANCE)
    If m_lGroupOffset > lOffset Then
        If bAnimate Then
            pvAnimateGroup lOffset
        Else
            m_lGroupOffset = lOffset
        End If
    End If
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

'= Private ===============================================================

Private Sub pvPropertyChanged()
    On Error Resume Next
    pvGetMeasures
    RefreshControl
    UserControl.PropertyChanged
End Sub
    
Private Sub pvFixGroupOffset()
'--- fix current group offset
    Dim lItemHeight     As Long
    Dim lMaxOffset      As Long

    On Error Resume Next
    '--- state check
    If m_oSelectedGroup Is Nothing Then
        Exit Sub
    End If
    If m_lGroupOffset < 0 Then
        m_lGroupOffset = 0
    Else
        pvGetItemInfo m_oSelectedGroup, lItemHeight, 0, 0
        lMaxOffset = Groups.Count * (m_lGroupHeight + 1) + m_oSelectedGroup.GroupItems.Count * (lItemHeight + ITEM_VERT_DISTANCE) - (ScaleHeight \ Screen.TwipsPerPixelY) + 2 * INNER_BORDER + 2 * m_oRendContrl.BorderSize - 1
        If m_lGroupOffset > lMaxOffset Then
            m_lGroupOffset = pvMax(lMaxOffset, 0)
        End If
    End If
End Sub

Private Sub pvPaintBorder( _
            ByVal oMemDC As cMemDC, _
            LeftX As Long, _
            TopY As Long, _
            RightX As Long, _
            BottomY As Long, _
            ByVal Border As UcsFormatBorderStyle, _
            Optional ByVal bSunken As Boolean = True, _
            Optional DblOffset As Long, _
            Optional clrBorder As OLE_COLOR)
    Const FUNC_NAME     As String = "pvPaintBorder"
    Dim lOffset         As Long
    Dim clrLeftTop      As OLE_COLOR
    Dim clrRightBottom  As OLE_COLOR
    
    With oMemDC
        .NormalizeRect LeftX, TopY, RightX, BottomY
        Select Case Border
        Case ucsFbdFixed
            .FrameRect LeftX, TopY, RightX, BottomY, clrBorder
            lOffset = 1
        Case ucsFbdSingle3D
'            .DrawEdge LeftX, TopY, RightX, BottomY, IIf(bSunken, BDR_SUNKENOUTER, BDR_RAISEDINNER)
            If bSunken Then
                clrLeftTop = clrBorder
                clrRightBottom = vbWhite
            Else
                clrLeftTop = vbWhite
                clrRightBottom = clrBorder
            End If
            .DrawLine LeftX, TopY, RightX, TopY, clrLeftTop
            .DrawLine LeftX, TopY, LeftX, BottomY, clrLeftTop
            .DrawLine LeftX, BottomY - 1, RightX, BottomY - 1, clrRightBottom
            .DrawLine RightX - 1, TopY, RightX - 1, BottomY, clrRightBottom
            lOffset = 1
        Case ucsFbdDouble3D
            .DrawEdge LeftX - DblOffset, TopY - DblOffset, RightX, BottomY, IIf(bSunken, EDGE_SUNKEN, EDGE_RAISED)
            lOffset = 2 - DblOffset
        End Select
    End With
    '--- deflate paint rect
    LeftX = LeftX + lOffset
    TopY = TopY + lOffset
    RightX = RightX - lOffset
    BottomY = BottomY - lOffset
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Private Sub pvPaintGroup( _
            ByVal oMemDC As cMemDC, _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            oBtn As cButton)
    Const FUNC_NAME     As String = "pvPaintGroup"
    Dim oFmt            As cFormatDef
    Dim lAlign          As Long
    
    On Error GoTo EH
    With oMemDC
        If m_oPressed Is oBtn Then
            If m_oOver Is oBtn Then
                Set oFmt = m_oRendGrpPrs
            Else
                Set oFmt = m_oRendGrpHvr
            End If
        ElseIf m_oPressed Is Nothing And m_oOver Is oBtn Then
            Set oFmt = m_oRendGrpHvr
        ElseIf m_oSelectedGroup Is oBtn Then
            Set oFmt = m_oRendGrpSel
        Else
            Set oFmt = m_oRendGrpNrm
        End If
        pvFillGradient oMemDC, LeftX, TopY, RightX, BottomY, oFmt.BackGradient
        pvPaintBorder oMemDC, LeftX, TopY, RightX, BottomY, oFmt.Border, oFmt.BorderSunken, 1, oFmt.BorderColor
        Set .Font = oFmt.Font
        .ForeColor = oFmt.ForeColor
        lAlign = Array(DT_LEFT, DT_CENTER, DT_RIGHT)(oFmt.HorAlignment) _
              Or Array(DT_TOP, DT_VCENTER, DT_BOTTOM)(oFmt.VertAlignment)
        .DrawText oBtn.Caption, _
                    LeftX + oFmt.Padding + oFmt.OffsetX, _
                    TopY + oFmt.Padding + oFmt.OffsetY, _
                    RightX - oFmt.Padding + oFmt.OffsetX, _
                    BottomY - oFmt.Padding + oFmt.OffsetY, _
                    lAlign Or DT_SINGLELINE Or DT_WORD_ELLIPSIS Or DT_WORDBREAK
    End With
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Private Sub pvPaintItem( _
            ByVal oMemDC As cMemDC, _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            oBtn As cButton, _
            ByVal lIconW As Long, _
            ByVal lIconH As Long, _
            oIcon As StdPicture)
    Const FUNC_NAME     As String = "pvPaintItem"
    Dim oFmt            As cFormatDef
    Dim oFmtIcon        As cFormatDef
    Dim lAlign          As Long
    Dim lIconX          As Long
    Dim lIconY          As Long
    Dim bResizeNeeded   As Boolean
    Dim bSmall          As Boolean
    
    On Error GoTo EH
    bSmall = oBtn.Parent.IconsType = ucsIcsSmallIcons
    With oMemDC
        If m_oPressed Is oBtn Then
            If m_oOver Is oBtn Then
                Set oFmt = IIf(bSmall, m_oRendItmPrs, m_oRendItmPrsLrg)
                Set oFmtIcon = IIf(bSmall, m_oRendSIcPrs, m_oRendLIcPrs)
            Else
                Set oFmt = IIf(bSmall, m_oRendItmHvr, m_oRendItmHvrLrg)
                Set oFmtIcon = IIf(bSmall, m_oRendSIcHvr, m_oRendLIcHvr)
            End If
        ElseIf m_oPressed Is Nothing And m_oOver Is oBtn Then
            Set oFmt = IIf(bSmall, m_oRendItmHvr, m_oRendItmHvrLrg)
            Set oFmtIcon = IIf(bSmall, m_oRendSIcHvr, m_oRendLIcHvr)
        ElseIf m_oSelectedItem Is oBtn Then
            Set oFmt = IIf(bSmall, m_oRendItmSel, m_oRendItmSelLrg)
            Set oFmtIcon = IIf(bSmall, m_oRendSIcSel, m_oRendLIcSel)
        Else
            Set oFmt = IIf(bSmall, m_oRendItmNrm, m_oRendItmNrmLrg)
            Set oFmtIcon = IIf(bSmall, m_oRendSIcNrm, m_oRendLIcNrm)
        End If
        
        pvFillGradient oMemDC, LeftX, TopY, RightX, BottomY, oFmt.BackGradient
        pvPaintBorder oMemDC, (LeftX), (TopY), (RightX), (BottomY), oFmt.Border, oFmt.BorderSunken, 0, oFmt.BorderColor
        bResizeNeeded = oFmt.VertAlignment <> oFmtIcon.VertAlignment And oFmt.HorAlignment = oFmtIcon.HorAlignment Or oFmtIcon.HorAlignment = ucsFhaCenter
        Select Case oFmtIcon.HorAlignment
        Case ucsFhaRight
            lIconX = RightX - oFmt.BorderSize - oFmt.Padding - oFmtIcon.Padding - lIconW
            If bResizeNeeded Or oFmt.VertAlignment = oFmtIcon.VertAlignment Then
                RightX = RightX - 2 * (oFmt.BorderSize + oFmt.Padding + oFmtIcon.Padding) - lIconW
            End If
        Case ucsFhaCenter
            lIconX = (RightX + LeftX - lIconW) \ 2
            '--- vert align will modify top or bottom
        Case Else ' ucsFhaLeft
            lIconX = LeftX + oFmt.BorderSize + oFmt.Padding + oFmtIcon.Padding
            If bResizeNeeded Or oFmt.VertAlignment = oFmtIcon.VertAlignment Then
                LeftX = LeftX + oFmt.BorderSize + 2 * oFmt.Padding + 2 * oFmtIcon.Padding + lIconW
            End If
        End Select
        Select Case oFmtIcon.VertAlignment
        Case ucsFvaBottom
            lIconY = BottomY - oFmt.BorderSize - oFmtIcon.Padding - lIconH
            If bResizeNeeded Then
                BottomY = BottomY - oFmt.BorderSize - lIconH - 2 * oFmtIcon.Padding
            End If
        Case ucsFvaMiddle
            lIconY = (BottomY + TopY - lIconH) \ 2
        Case Else ' ucsFvaTop
            lIconY = TopY + oFmt.BorderSize + oFmt.Padding + oFmtIcon.Padding
            If bResizeNeeded Then
                TopY = TopY + oFmt.BorderSize + lIconH + 2 * oFmtIcon.Padding  '+ oFmt.Padding
            End If
        End Select
        pvFillGradient oMemDC, lIconX - oFmtIcon.Padding, _
                lIconY - oFmtIcon.Padding, _
                lIconX + lIconW + oFmtIcon.Padding, _
                lIconY + lIconH + oFmtIcon.Padding, _
                oFmtIcon.BackGradient
        pvPaintBorder oMemDC, lIconX - oFmtIcon.Padding, _
                lIconY - oFmtIcon.Padding, _
                lIconX + lIconW + oFmtIcon.Padding, _
                lIconY + lIconH + oFmtIcon.Padding, oFmtIcon.Border, oFmtIcon.BorderSunken, 0, oFmtIcon.BorderColor
        If Not oIcon Is Nothing Then
            .PaintPicture oIcon, lIconX + oFmtIcon.OffsetX + (lIconW - pvHM2Pix(oIcon.Width)) \ 2, _
                    lIconY + oFmtIcon.OffsetY + (lIconH - pvHM2Pix(oIcon.Height)) \ 2, clrMask:=MaskColor
        End If
        '--- Hack: adhoc array, much like <C++> "0123456789"[Idx] </C++>
        lAlign = Array(DT_LEFT, DT_CENTER, DT_RIGHT)(oFmt.HorAlignment) _
              Or Array(DT_TOP, DT_VCENTER, DT_BOTTOM)(oFmt.VertAlignment)
        '--- check if multiline (or not)
        If InStr(oBtn.Caption, vbCrLf) > 0 Then
            lAlign = lAlign Or DT_WORD_ELLIPSIS Or DT_WORDBREAK
        Else
            lAlign = lAlign Or DT_SINGLELINE Or DT_WORD_ELLIPSIS Or DT_WORDBREAK
        End If
        Set .Font = oFmt.Font
        .ForeColor = oFmt.ForeColor
        .DrawText oBtn.Caption, _
                    LeftX + oFmt.Padding + oFmt.BorderSize + oFmt.OffsetX, _
                    TopY + oFmt.Padding + oFmt.BorderSize + oFmt.OffsetY, _
                    RightX - oFmt.Padding - oFmt.BorderSize + oFmt.OffsetX, _
                    BottomY - oFmt.Padding - oFmt.BorderSize + oFmt.OffsetY, _
                    lAlign
    End With
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Private Sub pvPaintGroupItems( _
            oMemDC As cMemDC, _
            ByVal lLeft As Long, _
            ByVal lTop As Long, _
            ByVal lRight As Long, _
            ByVal lBottom As Long, _
            ByVal oGroup As cButton, _
            ByVal lOffsetTop As Long, _
            ByVal bHideArrows As Boolean)
    Const FUNC_NAME     As String = "pvPaintGroupItems"
    Dim lItemHeight     As Long
    Dim lIconW          As Long
    Dim lIconH          As Long
    Dim oBtn            As cButton
    Dim lItmTop         As Long
    Dim rc              As RECT
    
    On Error GoTo EH
    pvGetItemInfo oGroup, lItemHeight, lIconW, lIconH
    With oMemDC
        lTop = lTop + INNER_BORDER
        lLeft = lLeft + INNER_BORDER
        lRight = lRight - INNER_BORDER
        lBottom = lBottom - INNER_BORDER
        If lTop < lBottom Then
            .SetClipRect lLeft, lTop, lRight, lBottom
            lItmTop = lTop - lOffsetTop
            For Each oBtn In oGroup.GroupItems
                If lItmTop + lItemHeight > lTop Then
                    pvPaintItem oMemDC, lLeft, lItmTop, lRight, lItmTop + lItemHeight, oBtn, _
                        lIconW, lIconH, IIf(oGroup.IconsType = ucsIcsSmallIcons, oBtn.SmallIcon, oBtn.LargeIcon)
                End If
                lItmTop = lItmTop + lItemHeight + ITEM_VERT_DISTANCE
                '--- beyond bottom of clipping area
                If lItmTop > lBottom Then
                    If Not bHideArrows Then
                        '--- down arrow
                        rc.Left = lRight - SCROLL_ARROW_SIZE
                        rc.Top = lBottom - SCROLL_ARROW_SIZE
                        rc.Right = lRight
                        rc.Bottom = lBottom
                        DrawFrameControl .hDC, rc, DFC_SCROLL, DFCS_SCROLLDOWN Or IIf((m_lScrollBtnState And 2) <> 0, DFCS_FLAT Or DFCS_PUSHED, 0)
                    End If
                    Exit For
                End If
            Next
            If lOffsetTop > 0 Then
                If Not bHideArrows Then
                    '--- up arrow
                    rc.Left = lRight - SCROLL_ARROW_SIZE
                    rc.Top = lTop
                    rc.Right = lRight
                    rc.Bottom = lTop + SCROLL_ARROW_SIZE
                    DrawFrameControl .hDC, rc, DFC_SCROLL, DFCS_SCROLLUP Or IIf((m_lScrollBtnState And 1) <> 0, DFCS_FLAT Or DFCS_PUSHED, 0)
                End If
            End If
        End If
    End With
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Private Sub pvPaintControl( _
            Optional ByVal lStep As Long, _
            Optional ByVal oPrevSlected As cButton)
    Const FUNC_NAME     As String = "pvPaintControl"
    Dim oMemDC          As cMemDC
    Dim lGroupHeight    As Long
    Dim lLeft           As Long
    Dim lTop            As Long
    Dim lRight          As Long
    Dim lBottom         As Long
    Dim lMiddle         As Long
    Dim lIdx            As Long
    Dim lBtmIdx         As Long
    Dim oGroup          As cButtons
    Dim hDC             As Long
    
    On Error GoTo EH
    lGroupHeight = m_lGroupHeight ' 300 \ Screen.TwipsPerPixelY
    If m_oRendContrl Is Nothing Then
        Set m_oRendContrl = m_oFmtContrl.Render
        Set m_oRendGrpNrm = m_oFmtGrpNrm.Render(m_oRendContrl)
        Set m_oRendGrpHvr = m_oFmtGrpHvr.Render(m_oRendGrpNrm)
        Set m_oRendGrpPrs = m_oFmtGrpPrs.Render(m_oRendGrpNrm)
        Set m_oRendGrpSel = m_oFmtGrpSel.Render(m_oRendGrpNrm)
        Set m_oRendItmNrm = m_oFmtItmNrm.Render(m_oRendContrl)
        Set m_oRendItmNrmLrg = m_oFmtItmLrg.Render(m_oRendContrl)
        Set m_oRendItmHvr = m_oFmtItmHvr.Render(m_oRendItmNrm)
        Set m_oRendItmHvrLrg = m_oFmtItmHvr.Render(m_oRendItmNrmLrg)
        Set m_oRendItmPrs = m_oFmtItmPrs.Render(m_oRendItmNrm)
        Set m_oRendItmPrsLrg = m_oFmtItmPrs.Render(m_oRendItmNrmLrg)
        Set m_oRendItmSel = m_oFmtItmSel.Render(m_oRendItmNrm)
        Set m_oRendItmSelLrg = m_oFmtItmSel.Render(m_oRendItmNrmLrg)
        Set m_oRendSIcNrm = m_oFmtSIcNrm.Render(m_oRendContrl)
        Set m_oRendSIcHvr = m_oFmtSIcHvr.Render(m_oRendSIcNrm)
        Set m_oRendSIcPrs = m_oFmtSIcPrs.Render(m_oRendSIcNrm)
        Set m_oRendSIcSel = m_oFmtSIcSel.Render(m_oRendSIcNrm)
        Set m_oRendLIcNrm = m_oFmtLIcNrm.Render(m_oRendContrl)
        Set m_oRendLIcHvr = m_oFmtLIcHvr.Render(m_oRendLIcNrm)
        Set m_oRendLIcPrs = m_oFmtLIcPrs.Render(m_oRendLIcNrm)
        Set m_oRendLIcSel = m_oFmtLIcSel.Render(m_oRendLIcNrm)
    End If
    Set oMemDC = New cMemDC
    With oMemDC
        '--- init
'        On Error Resume Next
        .Init ScaleWidth \ Screen.TwipsPerPixelX, ScaleHeight \ Screen.TwipsPerPixelY, , UserControl.hDC
        lRight = .Width
        lBottom = .Height
        '--- back and border
        pvPaintBorder oMemDC, lLeft, lTop, lRight, lBottom, m_oRendContrl.Border, True, 0, m_oRendContrl.BorderColor
        pvFillGradient oMemDC, lLeft, lTop, lRight, lBottom, m_oRendContrl.BackGradient
        '--- set dc parameters
        .SetClipRect lLeft, lTop, lRight, lBottom
        .BackStyle = BS_TRANSPARENT
        '--- loop groups on bottom
        For lIdx = Groups.Count To 2 Step -1
            If Groups(lIdx).Selected Or Groups(lIdx) Is oPrevSlected Then
                Exit For
            End If
            lBottom = lBottom - lGroupHeight - 1
            pvFillGradient oMemDC, lLeft, lBottom, lRight, lBottom + 1, FormatControl.BackGradient
            pvPaintGroup oMemDC, lLeft, lBottom + 1, lRight, lBottom + lGroupHeight + 1, Groups(lIdx)
        Next
        lBtmIdx = lIdx
        '--- loop groups on top
        lTop = lTop - 1
        For lIdx = 1 To lBtmIdx
            pvFillGradient oMemDC, lLeft, lTop, lRight, lTop + 1, FormatControl.BackGradient
            pvPaintGroup oMemDC, lLeft, lTop + 1, lRight, lTop + lGroupHeight + 1, Groups(lIdx)
            lTop = lTop + lGroupHeight + 1
            If Groups(lIdx).Selected Or Groups(lIdx) Is oPrevSlected Then
                Exit For
            End If
        Next
        If lIdx > lBtmIdx Then
            lIdx = lBtmIdx
        End If
        If lIdx < lBtmIdx Then
            lMiddle = lTop + ((lBottom - lTop - (lBtmIdx - lIdx) * (lGroupHeight + 1)) * lStep) \ (AnimationSteps + 1)
        Else
            lMiddle = lBottom
        End If
        '--- paint upper visible group items
        If lBottom > lTop Then
            If lIdx > 0 And lIdx <= Groups.Count Then
                pvPaintGroupItems oMemDC, lLeft, lTop, lRight, lMiddle, Groups(lIdx), lBottom - lMiddle - (lBtmIdx - lIdx) * (lGroupHeight + 1) + m_lGroupOffset, lStep > 0
            End If
        End If
        If lIdx < lBtmIdx Then
            lTop = lMiddle
            .SetClipRect lLeft, lTop, lRight, lBottom
            For lIdx = lIdx + 1 To lBtmIdx
                pvPaintGroup oMemDC, lLeft, lTop + 1, lRight, lTop + lGroupHeight + 1, Groups(lIdx)
                lTop = lTop + lGroupHeight + 1
            Next
            '--- paint lower visible group items
            If lBottom > lTop Then
                If lBtmIdx > 0 And lBtmIdx <= Groups.Count Then
                    pvPaintGroupItems oMemDC, lLeft, lTop, lRight, lBottom, Groups(lBtmIdx), 0, lStep > 0
                End If
            End If
        End If
        .SetClipRect -1
        '--- blit to control dc
        If .IsMemoryDC Then
            .BitBlt UserControl.hDC
        End If
    End With
    If AutoRedraw Then
        Refresh
    End If
    Exit Sub
EH:
    Debug.Print MODULE_NAME & "." & FUNC_NAME & ": " & Err.Description & " @ " & Err.Source
    Resume Next
'    RaiseError FUNC_NAME
End Sub

Private Sub pvFillGradient( _
            ByVal oMemDC As cMemDC, _
            ByVal LeftX As Long, _
            ByVal TopY As Long, _
            ByVal RightX As Long, _
            ByVal BottomY As Long, _
            ByVal oGrad As cGradientDef)
    Const FUNC_NAME     As String = "pvFillGradient"
    
    On Error GoTo EH
    With oMemDC
        Select Case oGrad.GradientType
        Case ucsGrdSolid
            .FillRect LeftX, TopY, RightX, BottomY, oGrad.Color
        Case ucsGrdVertical, ucsGrdHorizontal
            .FillGradient LeftX, TopY, RightX, BottomY, oGrad.Color, oGrad.SecondColor, oGrad.GradientType = ucsGrdVertical
        Case ucsGrdBlend
            .ForeColor = oGrad.Color
            .BackColor = oGrad.SecondColor
            .FillRect LeftX, TopY, RightX, BottomY, , .DotBrush
        End Select
    End With
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Private Sub pvGetItemInfo( _
            ByVal oGroup As cButton, _
            lItemHeight As Long, _
            lIconWidth As Long, _
            lIconHeight As Long)
    Const FUNC_NAME     As String = "pvGetItemInfo"
    Dim oIcnFmt         As cFormatDef
    Dim oBtn            As cButton
    Dim lSize           As Long
    Dim oIcon           As StdPicture
    Dim lIconBorder     As Long
    Dim lItemBorder     As Long
    Dim lTextLines      As Long
    
    On Error GoTo EH
    '--- state check
    If oGroup Is Nothing Then
        Exit Sub
    End If
    '--- figure out current icon format
    If oGroup.IconsType = ucsIcsSmallIcons Then
        Set oIcnFmt = m_oRendSIcNrm
    Else
        Set oIcnFmt = m_oRendLIcNrm
    End If
    '--- get icon max dimensions and text max lines
    For Each oBtn In oGroup.GroupItems
        If oGroup.IconsType = ucsIcsSmallIcons Then
            Set oIcon = oBtn.SmallIcon
        Else
            Set oIcon = oBtn.LargeIcon
        End If
        If Not oIcon Is Nothing Then
            If oIcon.handle <> 0 Then
                lIconHeight = pvMax(lIconHeight, pvHM2Pix(oIcon.Height))
                lIconWidth = pvMax(lIconWidth, pvHM2Pix(oIcon.Width))
            End If
        End If
        '--- number of vbCrLf's
        lTextLines = pvMax((Len(oBtn.Caption) - Len(Replace(oBtn.Caption, vbCrLf, ""))) \ Len(vbCrLf), lTextLines)
    Next
    lTextLines = lTextLines + 1
    '--- get max icon border size & max item border size
    If oGroup.IconsType = ucsIcsSmallIcons Then
        lIconBorder = pvMax(m_oRendSIcNrm.BorderSize + m_oRendSIcNrm.Padding, _
                    pvMax(m_oRendSIcHvr.BorderSize + m_oRendSIcHvr.Padding, _
                    pvMax(m_oRendSIcPrs.BorderSize + m_oRendSIcPrs.Padding, _
                    pvMax(m_oRendSIcSel.BorderSize + m_oRendSIcSel.Padding, lIconBorder))))
        lItemBorder = pvMax(m_oRendItmNrm.BorderSize + m_oRendItmNrm.Padding, _
                    pvMax(m_oRendItmHvr.BorderSize + m_oRendItmHvr.Padding, _
                    pvMax(m_oRendItmPrs.BorderSize + m_oRendItmPrs.Padding, _
                    pvMax(m_oRendItmSel.BorderSize + m_oRendItmSel.Padding, 0))))
    Else
        lIconBorder = pvMax(m_oRendLIcNrm.BorderSize + m_oRendLIcNrm.Padding, _
                    pvMax(m_oRendLIcHvr.BorderSize + m_oRendLIcHvr.Padding, _
                    pvMax(m_oRendLIcPrs.BorderSize + m_oRendLIcPrs.Padding, _
                    pvMax(m_oRendLIcSel.BorderSize + m_oRendLIcSel.Padding, lIconBorder))))
        lItemBorder = pvMax(m_oRendItmNrmLrg.BorderSize + m_oRendItmNrmLrg.Padding, _
                    pvMax(m_oRendItmHvrLrg.BorderSize + m_oRendItmHvrLrg.Padding, _
                    pvMax(m_oRendItmPrsLrg.BorderSize + m_oRendItmPrsLrg.Padding, _
                    pvMax(m_oRendItmSelLrg.BorderSize + m_oRendItmSelLrg.Padding, 0))))
    End If
    '--- calc item height based on composition of the icon
    If oIcnFmt.VertAlignment <> m_oRendItmNrm.VertAlignment And oIcnFmt.HorAlignment = m_oRendItmNrm.HorAlignment Or oIcnFmt.HorAlignment = ucsFhaCenter Then
        lItemHeight = lIconHeight + 2 * lIconBorder + lTextLines * m_lItemHeight + 2 * lItemBorder
    Else
        lItemHeight = pvMax(lIconHeight + 2 * lIconBorder, lTextLines * m_lItemHeight) + 2 * lItemBorder
    End If
    Exit Sub
EH:
    RaiseError FUNC_NAME
End Sub

Private Function pvLngUndef(ByVal lValue As Long) As Long
    On Error Resume Next
    If lValue = LNG_UNDEFINED Then
        pvLngUndef = 0
    Else
        pvLngUndef = lValue
    End If
End Function

Private Sub pvGetMeasures()
    Dim oMemDC          As New cMemDC
    
    On Error Resume Next
    Set m_oRendContrl = Nothing
    With oMemDC
        .Init , , , 0
        Set .Font = FormatControl.Font
        m_lItemHeight = .TextHeight("ABCH") '+ 6 + 2 * pvLngUndef(m_oFmtContrl.Padding)
'        Set .Font = FormatGroup.Font
        m_lGroupHeight = .TextHeight("ABCH") + 4 + 2 * FormatGroup.Render.Padding
    End With
End Sub

Private Function pvInitFormat( _
            oFmt As cFormatDef, _
            sName As String, _
            Optional oParent As cFormatDef, _
            Optional eBorder As UcsFormatBorderStyle = ucsFbd_Undefined, _
            Optional eGradientType As UcsGradientType = ucsGrd_Undefined, _
            Optional eHorAlign As UcsFormatHorAlignmentStyle = ucsFha_Undefined, _
            Optional eVertAlign As UcsFormatVertAlignmentStyle = ucsFva_Undefined, _
            Optional clrBorder As OLE_COLOR = vbButtonShadow, _
            Optional clrBackColor As OLE_COLOR = vbButtonFace) As Boolean
    On Error Resume Next
    If oFmt Is Nothing Then
        Set oFmt = New cFormatDef
        With oFmt
            .Name = sName
            Set .ParentFmt = oParent
            .Border = eBorder
            .BorderColor = clrBorder
            .BackGradient.GradientType = eGradientType
            .BackGradient.Color = clrBackColor
            .HorAlignment = eHorAlign
            .VertAlignment = eVertAlign
        End With
        '--- format just created
        pvInitFormat = True
    End If
End Function

Private Sub pvCreateTooltipWindow()
    On Error Resume Next
    '--- create the tooltip window
    m_hWndTooltip = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, vbNullString, WS_POPUP Or TTS_NOPREFIX Or TTS_ALWAYSTIP, 0, 0, 0, 0, UserControl.hwnd, 0, App.hInstance, ByVal 0)
    '--- make tooltips multi-line
    Call SendMessage(m_hWndTooltip, TTM_SETMAXTIPWIDTH, 0&, ByVal &H7FFF&)
End Sub

Private Function pvHM2Pix(ByVal Value As Double) As Double
   pvHM2Pix = Value * 1440 / 2540 / Screen.TwipsPerPixelX
End Function

Private Function pvMax(ByVal lA As Long, ByVal lB As Long) As Long
    pvMax = IIf(lB > lA, lB, lA)
End Function

Private Function pvMin(ByVal lA As Long, ByVal lB As Long) As Long
    pvMin = IIf(lB < lA, lB, lA)
End Function

'=========================================================================
' Control events
'=========================================================================

Private Sub UserControl_Initialize()
    Dim icc         As INITCOMMONCONTROLSEX
    
    On Error Resume Next
    Set m_oTop = New cButton
    m_oTop.Class = ucsBtnClassControl
    Set m_oFont = DEF_FONT
    Set m_oFmtContrl = DEF_CONTROL_FORMAT
    Set m_oFmtGrpNrm = DEF_GROUP_FORMAT
    Set m_oFmtGrpHvr = DEF_GROUP_FORMAT_HOVER
    Set m_oFmtGrpPrs = DEF_GROUP_FORMAT_PRESSED
    Set m_oFmtGrpSel = DEF_GROUP_FORMAT_SELECTED
    Set m_oFmtItmNrm = DEF_ITEM_FORMAT
    Set m_oFmtItmLrg = DEF_ITEM_FORMAT_LARGE_ICONS
    Set m_oFmtItmHvr = DEF_ITEM_FORMAT_HOVER
    Set m_oFmtItmPrs = DEF_ITEM_FORMAT_PRESSED
    Set m_oFmtItmSel = DEF_ITEM_FORMAT_SELECTED
    Set m_oFmtSIcNrm = DEF_SMALL_ICON_FORMAT
    Set m_oFmtSIcHvr = DEF_SMALL_ICON_FORMAT_HOVER
    Set m_oFmtSIcPrs = DEF_SMALL_ICON_FORMAT_PRESSED
    Set m_oFmtSIcSel = DEF_SMALL_ICON_FORMAT_SELECTED
    Set m_oFmtLIcNrm = DEF_LARGE_ICON_FORMAT
    Set m_oFmtLIcHvr = DEF_LARGE_ICON_FORMAT_HOVER
    Set m_oFmtLIcPrs = DEF_LARGE_ICON_FORMAT_PRESSED
    Set m_oFmtLIcSel = DEF_LARGE_ICON_FORMAT_SELECTED
    '--- initialize common controls
    icc.dwSize = LenB(icc)
    icc.dwICC = ICC_TAB_CLASSES
    Call ApiInitCommonControlsEx(icc)
    #If DebugMode Then
        DebugInit m_sDebugID, MODULE_NAME
    #End If
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
    If Not m_oOver Is Nothing Then
        RaiseEvent ButtonDblClick(m_oOver)
    End If
    mouse_event MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim oBtn            As cButton
    Dim lKey            As Long
    Dim lShift          As Long
    Dim lItemHeight     As Long
    
    '--- give user a chance to modify keys
    RaiseEvent KeyDown(KeyCode, Shift)
    '--- state check
    If m_oSelectedGroup Is Nothing Then
        Exit Sub
    End If
    '--- don't touch byref arguments
    lKey = KeyCode
    lShift = Shift
    '--- translate pageup/pagedown to group movement
    If lKey = vbKeyPageDown Then
        lKey = vbKeyDown: lShift = vbCtrlMask
    ElseIf lKey = vbKeyPageUp Then
        lKey = vbKeyUp: lShift = vbCtrlMask
    End If
    If lKey = vbKeyUp Then
        If lShift = 0 Then
            If m_oSelectedItem Is Nothing Then
                If m_oSelectedGroup.GroupItems.Count > 0 Then
                    Set oBtn = m_oSelectedGroup.GroupItems(1)
                End If
            ElseIf m_oSelectedItem.Index > 1 Then
                Set oBtn = m_oSelectedItem.Parent.GroupItems(m_oSelectedItem.Index - 1)
            Else
                '--- fall-through to group movement
                lShift = vbCtrlMask
            End If
        End If
        If lShift = vbCtrlMask Then
            If m_oSelectedGroup.Index > 1 Then
                m_oSelectedGroup.Parent.GroupItems(m_oSelectedGroup.Index - 1).Selected = True
                If m_oSelectedGroup.GroupItems.Count > 0 Then
                    Set oBtn = m_oSelectedGroup.GroupItems(m_oSelectedGroup.GroupItems.Count)
                    oBtn.Selected = True
                    '--- position offset to last element (no animation)
                    pvGetItemInfo oBtn.Parent, lItemHeight, 0, 0
                    m_lGroupOffset = oBtn.Parent.GroupItems.Count * (lItemHeight + ITEM_VERT_DISTANCE)
                End If
            Else
                If m_oSelectedGroup.GroupItems.Count > 0 Then
                    Set oBtn = m_oSelectedGroup.GroupItems(1)
                End If
            End If
        End If
    ElseIf lKey = vbKeyDown Then
        If lShift = 0 Then
            If m_oSelectedItem Is Nothing Then
                If m_oSelectedGroup.GroupItems.Count > 0 Then
                    Set oBtn = m_oSelectedGroup.GroupItems(1)
                End If
            ElseIf m_oSelectedItem.Index < m_oSelectedItem.Parent.GroupItems.Count Then
                Set oBtn = m_oSelectedItem.Parent.GroupItems(m_oSelectedItem.Index + 1)
            Else
                '--- fall-through to group movement
                lShift = vbCtrlMask
            End If
        End If
        If lShift = vbCtrlMask Then
            If m_oSelectedGroup.Index < m_oSelectedGroup.Parent.GroupItems.Count Then
                m_oSelectedGroup.Parent.GroupItems(m_oSelectedGroup.Index + 1).Selected = True
                If m_oSelectedGroup.GroupItems.Count > 0 Then
                    Set oBtn = m_oSelectedGroup.GroupItems(1)
                    oBtn.Selected = True
                    '--- position offset to start of group
                    m_lGroupOffset = 0
                End If
            Else
                If m_oSelectedGroup.GroupItems.Count > 0 Then
                    Set oBtn = m_oSelectedGroup.GroupItems(m_oSelectedGroup.GroupItems.Count)
                End If
            End If
        End If
    End If
    If Not oBtn Is Nothing Then
        oBtn.Selected = True
        EnsureVisible oBtn, True
    Else
        '--- otherwise draws scrollup arrow :-))
        m_lGroupOffset = 0
    End If
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub pvAnimateGroup(ByVal lToGroupOffset)
    Dim lStep           As Long
    Dim lGroupOffset    As Long
    Dim dblTimer        As Double
    
    On Error Resume Next
    UpdateWindow UserControl.hwnd
    lGroupOffset = m_lGroupOffset
    For lStep = 1 To AnimationSteps
        dblTimer = Timer
        m_lGroupOffset = lGroupOffset + (lToGroupOffset - lGroupOffset) * lStep \ AnimationSteps
        pvFixGroupOffset
        pvPaintControl
        Do While Timer <= dblTimer + 0.01
            Call Sleep(1)
        Loop
    Next
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim lItemHeight     As Long
    Dim eHit            As UcsHitTestEnum
    
    On Error Resume Next
    RaiseEvent MouseDown(Button, Shift, X, Y)
    If (Button And vbLeftButton) <> 0 Then
        eHit = HitTest(X, Y, m_oPressed)
        Set m_oOver = m_oPressed
        Select Case eHit
        Case ucsHitScrollupArrow, ucsHitScrolldownArrow
            m_lScrollBtnState = IIf(eHit = ucsHitScrollupArrow, 1, 2)
            pvGetItemInfo m_oSelectedGroup, lItemHeight, 0, 0
            pvAnimateGroup m_lGroupOffset + IIf(eHit = ucsHitScrollupArrow, -ScrollItemsCount, ScrollItemsCount) * (lItemHeight + ITEM_VERT_DISTANCE)
            m_lScrollBtnState = 0
        Case Else
            RefreshControl
        End Select
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim oPrev           As cButton
    Dim lStep           As Long
    Dim lScroll         As Long
    Dim dblTimer        As Double
    
    On Error Resume Next
    RaiseEvent MouseUp(Button, Shift, X, Y)
    If (Button And vbLeftButton) <> 0 Then
        Call HitTest(X, Y, m_oOver)
        If m_oOver Is m_oPressed _
                And Not m_oOver Is Nothing Then
            RaiseEvent ButtonClick(m_oOver)
            Set m_oPressed = Nothing
            If m_oOver.Class = ucsBtnClassItem Then
                Set SelectedItem = m_oOver
                EnsureVisible m_oOver, True
            Else
                '--- if selected group changed
                If Not m_oSelectedGroup Is m_oOver Then
                    UpdateWindow UserControl.hwnd
                    Set oPrev = SelectedGroup
                    Set m_oSelectedGroup = m_oOver
                    RaiseEvent SelGroupChange
                    m_lGroupOffset = 0
                    If Not m_oSelectedItem Is Nothing Then
                        If m_oSelectedGroup Is m_oSelectedItem.Parent Then
                            EnsureVisible m_oSelectedItem, False
                        End If
                    End If
                    For lStep = 1 To AnimationSteps
                        dblTimer = Timer
                        '--- figure out direction of the animation
                        pvPaintControl IIf(oPrev.Index < m_oOver.Index, AnimationSteps + 1 - lStep, lStep), oPrev
                        Do While Timer <= dblTimer + 0.01
                            Call Sleep(1)
                        Loop
                    Next
                    pvPaintControl 0, m_oOver
                End If
            End If
        Else
            Set m_oPressed = Nothing
        End If
        Call HitTest(X, Y, m_oOver)
        RefreshControl
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim oBtn            As cButton
    
    On Error Resume Next
    RaiseEvent MouseMove(Button, Shift, X, Y)
    Call HitTest(X, Y, oBtn)
    If Not oBtn Is m_oOver Then
        Set m_oOver = oBtn
        If Not m_oOver Is Nothing Then
            ApiTooltipText = m_oOver.TooltipText
        End If
        RefreshControl
    End If
    If X >= 0 And X < ScaleWidth And Y >= 0 And Y < ScaleHeight And Button = 0 Then
        If GetCapture() <> UserControl.hwnd Then
            SetCapture UserControl.hwnd
        End If
    Else
        If GetCapture() = UserControl.hwnd And Button = 0 Then
            ReleaseCapture
        End If
    End If
End Sub

Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
    If OleDragMode = ucsOleDragAutomatic Then
        Dim oBtn            As cButton
    
        Call HitTest(X, Y, oBtn)
        If Not oBtn Is Nothing Then
            If oBtn.Class = ucsBtnClassGroup Then
                oBtn.Selected = True
            End If
        End If
    End If
End Sub

Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

Private Sub UserControl_Paint()
    Const FUNC_NAME     As String = "UserControl_Paint"
    
    On Error GoTo EH
    AutoRedraw = True
    pvPaintControl
    Exit Sub
EH:
    Select Case ShowError(FUNC_NAME)
    Case vbRetry: Resume
    Case vbIgnore: Resume Next
    End Select
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    If Not m_oSelectedItem Is Nothing Then
        If m_oSelectedGroup Is m_oSelectedItem.Parent Then
            EnsureVisible m_oSelectedItem, False
        End If
    End If
    RefreshControl
End Sub

Private Sub UserControl_Terminate()
    PushError
    On Error Resume Next
    '--- destroy tooltip window
    If m_hWndTooltip <> 0 Then
        Call DestroyWindow(m_hWndTooltip)
        m_hWndTooltip = 0
    End If
    '--- clean up
    Set m_oSelectedGroup = Nothing
    Set m_oSelectedItem = Nothing
    If Not m_oTop.Items Is Nothing Then
        m_oTop.Items.Clear
        Set m_oTop.Items = Nothing
    End If
    Set m_oTop = Nothing
    Set m_oOver = Nothing
    Set m_oPressed = Nothing
    #If DebugMode Then
        DebugTerm m_sDebugID
    #End If
    PopError
End Sub

Private Sub UserControl_InitProperties()
    On Error Resume Next
    Groups.Add "Button Group"
    pvGetMeasures
    MaskColor = DEF_MASKCOLOR
    AnimationSteps = DEF_ANIMSTEPS
    OleDragMode = DEF_OLEDRAGMODE
    OleDropMode = DEF_OLEDROPMODE
    ScrollItemsCount = DEF_SCROLLITEMSCOUNT
    pvCreateTooltipWindow
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Const FUNC_NAME     As String = "UserControl_ReadProperties"
    
    On Error GoTo EH
    With PropBag
        Set Font = .ReadProperty("Font", DEF_FONT)
        FormatControl.Contents = .ReadProperty("FormatControl", DEF_GROUP_FORMAT.Contents)
        FormatGroup.Contents = .ReadProperty("FormatGroup", DEF_GROUP_FORMAT.Contents)
        FormatGroupHover.Contents = .ReadProperty("FormatGroupHover", DEF_GROUP_FORMAT_HOVER.Contents)
        FormatGroupPressed.Contents = .ReadProperty("FormatGroupPressed", DEF_GROUP_FORMAT_PRESSED.Contents)
        FormatGroupSelected.Contents = .ReadProperty("FormatGroupSelected", DEF_GROUP_FORMAT_SELECTED.Contents)
        FormatItem.Contents = .ReadProperty("FormatItem", DEF_ITEM_FORMAT.Contents)
        FormatItemLargeIcons.Contents = .ReadProperty("FormatItemLargeIcons", DEF_ITEM_FORMAT_LARGE_ICONS.Contents)
        FormatItemHover.Contents = .ReadProperty("FormatItemHover", DEF_ITEM_FORMAT_HOVER.Contents)
        FormatItemPressed.Contents = .ReadProperty("FormatItemPressed", DEF_ITEM_FORMAT_PRESSED.Contents)
        FormatItemSelected.Contents = .ReadProperty("FormatItemSelected", DEF_ITEM_FORMAT_SELECTED.Contents)
        FormatSmallIcon.Contents = .ReadProperty("FormatSmallIcon", DEF_SMALL_ICON_FORMAT.Contents)
        FormatSmallIconHover.Contents = .ReadProperty("FormatSmallIconHover", DEF_SMALL_ICON_FORMAT_HOVER.Contents)
        FormatSmallIconPressed.Contents = .ReadProperty("FormatSmallIconPressed", DEF_SMALL_ICON_FORMAT_PRESSED.Contents)
        FormatSmallIconSelected.Contents = .ReadProperty("FormatSmallIconSelected", DEF_SMALL_ICON_FORMAT_SELECTED.Contents)
        FormatLargeIcon.Contents = .ReadProperty("FormatLargeIcon", DEF_LARGE_ICON_FORMAT.Contents)
        FormatLargeIconHover.Contents = .ReadProperty("FormatLargeIconHover", DEF_LARGE_ICON_FORMAT_HOVER.Contents)
        FormatLargeIconPressed.Contents = .ReadProperty("FormatLargeIconPressed", DEF_LARGE_ICON_FORMAT_PRESSED.Contents)
        FormatLargeIconSelected.Contents = .ReadProperty("FormatLargeIconSelected", DEF_LARGE_ICON_FORMAT_SELECTED.Contents)
        MaskColor = .ReadProperty("MaskColor", DEF_MASKCOLOR)
        Groups.Contents = .ReadProperty("Groups", "")
        AnimationSteps = .ReadProperty("AnimationSteps", DEF_ANIMSTEPS)
        OleDragMode = .ReadProperty("OleDragMode", DEF_OLEDRAGMODE)
        OleDropMode = .ReadProperty("OleDropMode", DEF_OLEDROPMODE)
        ScrollItemsCount = .ReadProperty("ScrollItemsCount", DEF_SCROLLITEMSCOUNT)
    End With
    pvCreateTooltipWindow
    Exit Sub
EH:
    Select Case ShowError(FUNC_NAME)
    Case vbRetry: Resume
    Case vbIgnore: Resume Next
    End Select
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Const FUNC_NAME     As String = "UserControl_WriteProperties"
    
    On Error GoTo EH
    With PropBag
        Call .WriteProperty("Font", Font, DEF_FONT)
        Call .WriteProperty("FormatControl", FormatControl.Contents, DEF_GROUP_FORMAT.Contents)
        Call .WriteProperty("FormatGroup", FormatGroup.Contents, DEF_GROUP_FORMAT.Contents)
        Call .WriteProperty("FormatGroupHover", FormatGroupHover.Contents, DEF_GROUP_FORMAT_HOVER.Contents)
        Call .WriteProperty("FormatGroupPressed", FormatGroupPressed.Contents, DEF_GROUP_FORMAT_PRESSED.Contents)
        Call .WriteProperty("FormatGroupSelected", FormatGroupSelected.Contents, DEF_GROUP_FORMAT_SELECTED.Contents)
        Call .WriteProperty("FormatItem", FormatItem.Contents, DEF_ITEM_FORMAT.Contents)
        Call .WriteProperty("FormatItemLargeIcons", FormatItemLargeIcons.Contents, DEF_ITEM_FORMAT_LARGE_ICONS.Contents)
        Call .WriteProperty("FormatItemHover", FormatItemHover.Contents, DEF_ITEM_FORMAT_HOVER.Contents)
        Call .WriteProperty("FormatItemPressed", FormatItemPressed.Contents, DEF_ITEM_FORMAT_PRESSED.Contents)
        Call .WriteProperty("FormatItemSelected", FormatItemSelected.Contents, DEF_ITEM_FORMAT_SELECTED.Contents)
        Call .WriteProperty("FormatSmallIcon", FormatSmallIcon.Contents, DEF_SMALL_ICON_FORMAT.Contents)
        Call .WriteProperty("FormatSmallIconHover", FormatSmallIconHover.Contents, DEF_SMALL_ICON_FORMAT_HOVER.Contents)
        Call .WriteProperty("FormatSmallIconPressed", FormatSmallIconPressed.Contents, DEF_SMALL_ICON_FORMAT_PRESSED.Contents)
        Call .WriteProperty("FormatSmallIconSelected", FormatSmallIconSelected.Contents, DEF_SMALL_ICON_FORMAT_SELECTED.Contents)
        Call .WriteProperty("FormatLargeIcon", FormatLargeIcon.Contents, DEF_LARGE_ICON_FORMAT.Contents)
        Call .WriteProperty("FormatLargeIconHover", FormatLargeIconHover.Contents, DEF_LARGE_ICON_FORMAT_HOVER.Contents)
        Call .WriteProperty("FormatLargeIconPressed", FormatLargeIconPressed.Contents, DEF_LARGE_ICON_FORMAT_PRESSED.Contents)
        Call .WriteProperty("FormatLargeIconSelected", FormatLargeIconSelected.Contents, DEF_LARGE_ICON_FORMAT_SELECTED.Contents)
        Call .WriteProperty("MaskColor", MaskColor, DEF_MASKCOLOR)
        Call .WriteProperty("Groups", Groups.Contents)
        Call .WriteProperty("AnimationSteps", AnimationSteps, DEF_ANIMSTEPS)
        Call .WriteProperty("OleDragMode", OleDragMode, DEF_OLEDRAGMODE)
        Call .WriteProperty("OleDropMode", OleDropMode, DEF_OLEDROPMODE)
        Call .WriteProperty("ScrollItemsCount", ScrollItemsCount, DEF_SCROLLITEMSCOUNT)
    End With
    Exit Sub
EH:
    Select Case ShowError(FUNC_NAME)
    Case vbRetry: Resume
    Case vbIgnore: Resume Next
    End Select
End Sub

Private Sub m_oFmtContrl_ControlFont(oFont As stdole.StdFont)
    Set oFont = Font
End Sub

Private Sub m_oFmtContrl_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtGrpNrm_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtGrpHvr_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtGrpPrs_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtGrpSel_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtItmNrm_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtItmLrg_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtItmHvr_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtItmPrs_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtItmSel_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtSIcNrm_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtSIcHvr_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtSIcPrs_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFmtSIcSel_Changed()
    pvPropertyChanged
End Sub

Private Sub m_oFont_FontChanged(ByVal PropertyName As String)
    pvPropertyChanged
End Sub

Private Sub m_oTop_GetControl(oValue As ctxOutlookBar)
    Set oValue = Me
End Sub

